// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.1.0.post0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112313, 0.08417937871268438, -0.11664236870396101, 0.0, -0.14682003422210352, 0.07290148043997555, -0.10101525445522093 },
          { 0.0, 0.0, 0.0, 0.32167832742366925, -0.1346870059402947, 0.09720197391996731, 0.26057971086461396, -0.12987926104263006, 0.09768798378956722, -0.06313453403451319 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.0782460796435952, -0.16835875742536827, 0.3499271061118823, 0.0, 0.06776309271789385, -0.14580296087995093, 0.3030457633656628 },
          { 0.0, 0.0, 0.0, -0.1651861681364794, 0.23570226039551598, -0.27216552697590846, -0.12026755886059129, 0.14682003422210385, -0.22453655975512465, 0.1767766952966371 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179779, -0.0841793787126843, -0.34992710611188255, 0.0, -0.03388154635894705, -0.07290148043997552, -0.3030457633656632 },
          { 0.0, 0.0, 0.0, 0.06085806194501886, 0.0, 0.21384434262392854, 0.060133779430295596, 0.039528470752104396, 0.11226827987756251, -0.1388959748759294 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268391, 0.11664236870396107, 0.0, 0.14682003422210332, 0.07290148043997538, 0.10101525445522108 },
          { 0.0, 0.0, 0.0, 0.4912114999847919, 0.21886638465297883, 0.2138443426239282, -0.2605797108646134, 0.016940773179473293, -0.024786503349591683, 0.037880720420707975 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359526, -0.16835875742536838, -0.3499271061118826, 0.0, -0.06776309271789394, -0.14580296087995098, -0.3030457633656631 },
          { 0.0, 0.0, 0.0, -0.2434322477800737, -0.4040610178208844, -0.6220926330877912, 0.1202675588605907, 0.07905694150420937, 0.07873359887517363, -0.12626906806902669 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179753, -0.08417937871268408, 0.3499271061118824, 0.0, 0.03388154635894687, -0.07290148043997527, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.09998110176681556, -0.08417937871268406, 0.5637714487358106, -0.06013377943029552, 0.07341001711105193, -0.1851697603175378, 0.1641497884897345 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.30304576336566313, 0.31104631654389575, 0.0, -0.0903507902905253, -0.14580296087995095, -0.20203050891044227 },
          { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268415, 0.11664236870396108, 0.16035674514745446, 0.06776309271789378, 0.03207665139358939, -0.07576144084141614 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373747, 0.0, -0.1555231582719478, 0.0, 0.1807015805810504, 0.0, 0.10101525445522141 },
          { 0.0, 0.0, 0.0, -0.3825363893686873, 0.06734350297014764, -0.07776157913597401, -0.3207134902949091, 0.09035079029052528, -0.06415330278717872, 0.05050762722761077 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686875, -0.30304576336566386, 0.31104631654389586, 0.0, -0.09035079029052505, 0.1458029608799511, -0.2020305089104421 },
          { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297936, 0.19440394783993467, 0.16035674514745477, -0.15811388300841941, 0.17787961227354046, -0.12626906806902655 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.36885555678165927, -0.4761904761904756, -1.6495721976846458, 0.0, -0.3194382824999707, -0.4123930494211605, 0.5714285714285697 },
          { 0.0, 0.0, 0.0, 0.6147592613027627, 0.4761904761904764, -0.5498573992282132, 0.5669467095138399, 0.1597191412499862, -0.4536323543632768, 0.3571428571428571 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999987, 0.0, -0.6776309271789399, 1.8079567149113966, 0.0, 0.0, -0.5868455973269647, -1.262690680690262, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894572, 1.16642368703961, -0.3367175148507358, 1.0415476122441183, 0.6846531968814596, -0.5808377131175211, 0.21870444131992603 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 4.0, 0.13041013273932345, -0.8417937871268435, 0.9331389496316886, 0.0, 0.11293848786315588, -0.7290148043997556, -2.020305089104419 },
          { 0.0, 0.0, 0.0, -0.34776035397153165, 0.3367175148507345, 1.3608276348795452, -0.200445931434318, 0.6211616832473581, 0.5977921396078001, -0.8838834764831862 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809516, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.0, 0.0, 0.0, -1.5983740793871863, 0.476190476190476, -0.549857399228217, 0.0, -0.6388765649999409, 0.4123930494211607, -0.1428571428571423 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578785, 0.0, 0.0, 0.0, 1.173691194653928, 0.0, 0.0 },
          { 0.0, 3.9999999999999973, 0.0, 0.67763092717894, -0.5248906591678244, 0.0, -2.0830952244882384, 0.5868455973269622, -0.10101525445522107, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.4580296087995095, 0.0 },
          { 0.0, 0.0, 3.999999999999998, 0.825930840682395, 0.8417937871268417, -1.7885163201274021, 0.0, -1.129384878631565, 0.7290148043997546, -0.2525381361380525 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129201, 0.0, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
            { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112313, 0.08417937871268438, -0.11664236870396101, 0.0, -0.14682003422210352, 0.07290148043997555, -0.10101525445522093 },
          { 0.0, 0.0, 0.0, 0.32167832742366925, -0.1346870059402947, 0.09720197391996731, 0.26057971086461396, -0.12987926104263006, 0.09768798378956722, -0.06313453403451319 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.0782460796435952, -0.16835875742536827, 0.3499271061118823, 0.0, 0.06776309271789385, -0.14580296087995093, 0.3030457633656628 },
          { 0.0, 0.0, 0.0, -0.1651861681364794, 0.23570226039551598, -0.27216552697590846, -0.12026755886059129, 0.14682003422210385, -0.22453655975512465, 0.1767766952966371 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179779, -0.0841793787126843, -0.34992710611188255, 0.0, -0.03388154635894705, -0.07290148043997552, -0.3030457633656632 },
          { 0.0, 0.0, 0.0, 0.06085806194501886, 0.0, 0.21384434262392854, 0.060133779430295596, 0.039528470752104396, 0.11226827987756251, -0.1388959748759294 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268391, 0.11664236870396107, 0.0, 0.14682003422210332, 0.07290148043997538, 0.10101525445522108 },
          { 0.0, 0.0, 0.0, 0.4912114999847919, 0.21886638465297883, 0.2138443426239282, -0.2605797108646134, 0.016940773179473293, -0.024786503349591683, 0.037880720420707975 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359526, -0.16835875742536838, -0.3499271061118826, 0.0, -0.06776309271789394, -0.14580296087995098, -0.3030457633656631 },
          { 0.0, 0.0, 0.0, -0.2434322477800737, -0.4040610178208844, -0.6220926330877912, 0.1202675588605907, 0.07905694150420937, 0.07873359887517363, -0.12626906806902669 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179753, -0.08417937871268408, 0.3499271061118824, 0.0, 0.03388154635894687, -0.07290148043997527, 0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.09998110176681556, -0.08417937871268406, 0.5637714487358106, -0.06013377943029552, 0.07341001711105193, -0.1851697603175378, 0.1641497884897345 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686871, 0.30304576336566313, 0.31104631654389575, 0.0, -0.0903507902905253, -0.14580296087995095, -0.20203050891044227 },
          { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268415, 0.11664236870396108, 0.16035674514745446, 0.06776309271789378, 0.03207665139358939, -0.07576144084141614 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373747, 0.0, -0.1555231582719478, 0.0, 0.1807015805810504, 0.0, 0.10101525445522141 },
          { 0.0, 0.0, 0.0, -0.3825363893686873, 0.06734350297014764, -0.07776157913597401, -0.3207134902949091, 0.09035079029052528, -0.06415330278717872, 0.05050762722761077 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686875, -0.30304576336566386, 0.31104631654389586, 0.0, -0.09035079029052505, 0.1458029608799511, -0.2020305089104421 },
          { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297936, 0.19440394783993467, 0.16035674514745477, -0.15811388300841941, 0.17787961227354046, -0.12626906806902655 } };
    static const double coefficients9[2][10] =
        { { 3.999999999999999, 0.0, 0.0, -0.36885555678165927, -0.4761904761904756, -1.6495721976846458, 0.0, -0.3194382824999707, -0.4123930494211605, 0.5714285714285697 },
          { 0.0, 0.0, 0.0, 0.6147592613027627, 0.4761904761904764, -0.5498573992282132, 0.5669467095138399, 0.1597191412499862, -0.4536323543632768, 0.3571428571428571 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999987, 0.0, -0.6776309271789399, 1.8079567149113966, 0.0, 0.0, -0.5868455973269647, -1.262690680690262, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894572, 1.16642368703961, -0.3367175148507358, 1.0415476122441183, 0.6846531968814596, -0.5808377131175211, 0.21870444131992603 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 4.0, 0.13041013273932345, -0.8417937871268435, 0.9331389496316886, 0.0, 0.11293848786315588, -0.7290148043997556, -2.020305089104419 },
          { 0.0, 0.0, 0.0, -0.34776035397153165, 0.3367175148507345, 1.3608276348795452, -0.200445931434318, 0.6211616832473581, 0.5977921396078001, -0.8838834764831862 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809516, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.0, 0.0, 0.0, -1.5983740793871863, 0.476190476190476, -0.549857399228217, 0.0, -0.6388765649999409, 0.4123930494211607, -0.1428571428571423 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578785, 0.0, 0.0, 0.0, 1.173691194653928, 0.0, 0.0 },
          { 0.0, 3.9999999999999973, 0.0, 0.67763092717894, -0.5248906591678244, 0.0, -2.0830952244882384, 0.5868455973269622, -0.10101525445522107, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.4580296087995095, 0.0 },
          { 0.0, 0.0, 3.999999999999998, 0.825930840682395, 0.8417937871268417, -1.7885163201274021, 0.0, -1.129384878631565, 0.7290148043997546, -0.2525381361380525 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112313, 0.08417937871268438, -0.11664236870396101, 0.0, -0.14682003422210352, 0.07290148043997555, -0.10101525445522093 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.32167832742366925, -0.1346870059402947, 0.09720197391996731, 0.26057971086461396, -0.12987926104263006, 0.09768798378956722, -0.06313453403451319 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0782460796435952, -0.16835875742536827, 0.3499271061118823, 0.0, 0.06776309271789385, -0.14580296087995093, 0.3030457633656628 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.1651861681364794, 0.23570226039551598, -0.27216552697590846, -0.12026755886059129, 0.14682003422210385, -0.22453655975512465, 0.1767766952966371 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179779, -0.0841793787126843, -0.34992710611188255, 0.0, -0.03388154635894705, -0.07290148043997552, -0.3030457633656632 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501886, 0.0, 0.21384434262392854, 0.060133779430295596, 0.039528470752104396, 0.11226827987756251, -0.1388959748759294 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268391, 0.11664236870396107, 0.0, 0.14682003422210332, 0.07290148043997538, 0.10101525445522108 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847919, 0.21886638465297883, 0.2138443426239282, -0.2605797108646134, 0.016940773179473293, -0.024786503349591683, 0.037880720420707975 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359526, -0.16835875742536838, -0.3499271061118826, 0.0, -0.06776309271789394, -0.14580296087995098, -0.3030457633656631 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.2434322477800737, -0.4040610178208844, -0.6220926330877912, 0.1202675588605907, 0.07905694150420937, 0.07873359887517363, -0.12626906806902669 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179753, -0.08417937871268408, 0.3499271061118824, 0.0, 0.03388154635894687, -0.07290148043997527, 0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681556, -0.08417937871268406, 0.5637714487358106, -0.06013377943029552, 0.07341001711105193, -0.1851697603175378, 0.1641497884897345 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686871, 0.30304576336566313, 0.31104631654389575, 0.0, -0.0903507902905253, -0.14580296087995095, -0.20203050891044227 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268415, 0.11664236870396108, 0.16035674514745446, 0.06776309271789378, 0.03207665139358939, -0.07576144084141614 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373747, 0.0, -0.1555231582719478, 0.0, 0.1807015805810504, 0.0, 0.10101525445522141 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686873, 0.06734350297014764, -0.07776157913597401, -0.3207134902949091, 0.09035079029052528, -0.06415330278717872, 0.05050762722761077 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686875, -0.30304576336566386, 0.31104631654389586, 0.0, -0.09035079029052505, 0.1458029608799511, -0.2020305089104421 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297936, 0.19440394783993467, 0.16035674514745477, -0.15811388300841941, 0.17787961227354046, -0.12626906806902655 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 3.999999999999999, 0.0, 0.0, -0.36885555678165927, -0.4761904761904756, -1.6495721976846458, 0.0, -0.3194382824999707, -0.4123930494211605, 0.5714285714285697 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027627, 0.4761904761904764, -0.5498573992282132, 0.5669467095138399, 0.1597191412499862, -0.4536323543632768, 0.3571428571428571 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.9999999999999987, 0.0, -0.6776309271789399, 1.8079567149113966, 0.0, 0.0, -0.5868455973269647, -1.262690680690262, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894572, 1.16642368703961, -0.3367175148507358, 1.0415476122441183, 0.6846531968814596, -0.5808377131175211, 0.21870444131992603 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 4.0, 0.13041013273932345, -0.8417937871268435, 0.9331389496316886, 0.0, 0.11293848786315588, -0.7290148043997556, -2.020305089104419 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.34776035397153165, 0.3367175148507345, 1.3608276348795452, -0.200445931434318, 0.6211616832473581, 0.5977921396078001, -0.8838834764831862 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809516, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 };
            static const double coefficients1[10] = { 4.0, 0.0, 0.0, -1.5983740793871863, 0.476190476190476, -0.549857399228217, 0.0, -0.6388765649999409, 0.4123930494211607, -0.1428571428571423 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578785, 0.0, 0.0, 0.0, 1.173691194653928, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.9999999999999973, 0.0, 0.67763092717894, -0.5248906591678244, 0.0, -2.0830952244882384, 0.5868455973269622, -0.10101525445522107, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.4580296087995095, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.999999999999998, 0.825930840682395, 0.8417937871268417, -1.7885163201274021, 0.0, -1.129384878631565, 0.7290148043997546, -0.2525381361380525 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566351, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505142, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999956, 0.0, 7.0710678118654675, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129201, -4.0407610680379375e-14, -2.9933259094191595, 13.66260102127946, 0.0, 0.6110100926607812, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.3817804600413295, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377566, 0.0, 7.838367176906176, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.581988897471621, 4.7434164902525735, -0.9128709291752798, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999143, 6.123724356957935, 3.5355339059327338, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584923, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645756, 5.184592558726257, -1.4966629547095662, 6.8313005106397275, -1.058300524425831, 0.3055050463303893, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499828, 2.190890230020673, 2.529822128134681, 8.082903768654777, 6.260990336999407, -1.8073922282301231, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688794, -5.091168824543145, 3.919183588453098, 0.0, 9.69948452238569, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000024, 0.0, -2.8284271247462294, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 3.0) + dof_values[4] * (K[2] * -2.9999999999999982) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 2.9999999999999996) + dof_values[7] * (K[0] * -2.9999999999999987) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.000000000000001) + dof_values[1] * (K[2] * -3.0000000000000044) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0000000000000004 + K[2] * -3.000000000000001) + dof_values[8] * (K[0] * 3.0000000000000013 + K[2] * 3.0000000000000036);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.9999999999999964) + dof_values[2] * (K[0] * -2.999999999999999) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.999999999999999 + K[2] * -3.0000000000000018) + dof_values[5] * (K[0] * 2.9999999999999973 + K[2] * 3.0000000000000013);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 3.0) + dof_values[4] * (K[2 + 1] * -2.9999999999999982) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 2.9999999999999996) + dof_values[7] * (K[1] * -2.9999999999999987) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.000000000000001) + dof_values[1] * (K[2 + 1] * -3.0000000000000044) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0000000000000004 + K[2 + 1] * -3.000000000000001) + dof_values[8] * (K[1] * 3.0000000000000013 + K[2 + 1] * 3.0000000000000036);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.9999999999999964) + dof_values[2] * (K[1] * -2.999999999999999) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.999999999999999 + K[2 + 1] * -3.0000000000000018) + dof_values[5] * (K[1] * 2.9999999999999973 + K[2 + 1] * 3.0000000000000013);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.3333333333333333, 0.3333333333333333, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333339 * sp[33] + 0.3583333333333384 * sp[34] + -0.6083333333333357 * sp[28] + -0.6083333333333294 * sp[31] + 0.3583333333333384 * sp[34] + 0.8583333333333474 * sp[35] + -1.875000000000022 * sp[29] + -0.6083333333333408 * sp[32] + -0.6083333333333357 * sp[28] + -1.875000000000022 * sp[29] + 6.191666666666705 * sp[26] + 1.691666666666671 * sp[27] + -0.6083333333333294 * sp[31] + -0.6083333333333408 * sp[32] + 1.691666666666671 * sp[27] + 0.6333333333333336 * sp[30];
    A[1] = -2.016666666666666 * sp[33] + 1.116666666666661 * sp[34] + -0.6166666666666658 * sp[28] + -0.6166666666666784 * sp[31] + 0.2833333333333347 * sp[34] + -0.8000000000000096 * sp[35] + sp[29] + -0.6166666666666797 * sp[32] + 0.2166666666666655 * sp[28] + 1.666666666666683 * sp[29] + -3.466666666666693 * sp[26] + 2.783333333333351 * sp[27] + 0.2166666666666593 * sp[31] + 0.2166666666666752 * sp[32] + -0.7166666666666717 * sp[27] + 0.8166666666666658 * sp[30];
    A[2] = -0.03333333333333005 * sp[33] + -0.8916666666666634 * sp[34] + -0.1916666666666666 * sp[28] + -0.1916666666666629 * sp[31] + 0.4416666666666715 * sp[34] + 1.27500000000001 * sp[35] + -0.7916666666666754 * sp[29] + -0.1916666666666607 * sp[32] + -0.1916666666666688 * sp[28] + -0.7916666666666742 * sp[29] + 1.275000000000011 * sp[26] + -0.8916666666666752 * sp[27] + -0.1916666666666705 * sp[31] + -0.1916666666666747 * sp[32] + 0.4416666666666704 * sp[27] + -0.03333333333333155 * sp[30];
    A[3] = -1.591666666666672 * sp[33] + -0.6500000000000026 * sp[34] + -2.283333333333345 * sp[28] + -0.6500000000000101 * sp[31] + -0.9416666666666754 * sp[34] + -1.295833333333347 * sp[35] + -0.1125000000000024 * sp[29] + -0.4666666666666724 * sp[32] + 0.6916666666666702 * sp[28] + 1.52083333333335 * sp[29] + -1.095833333333333 * sp[26] + -0.2666666666666608 * sp[27] + 0.6916666666666687 * sp[31] + 0.691666666666673 * sp[32] + 0.6916666666666694 * sp[27] + 0.5083333333333396 * sp[30];
    A[4] = -0.06666666666666232 * sp[33] + -0.5333333333333303 * sp[34] + -0.09999999999999176 * sp[28] + -0.5333333333333297 * sp[31] + 0.8833333333333417 * sp[34] + 1.675000000000012 * sp[35] + 0.1416666666666702 * sp[29] + 0.9333333333333309 * sp[32] + -0.3833333333333367 * sp[28] + -0.9583333333333418 * sp[29] + 0.4416666666666616 * sp[26] + -0.1333333333333339 * sp[27] + -0.3833333333333399 * sp[31] + -0.3833333333333421 * sp[32] + -0.3833333333333407 * sp[27] + -0.600000000000008 * sp[30];
    A[5] = -1.008333333333331 * sp[33] + 1.18333333333333 * sp[34] + -2.116666666666667 * sp[28] + 1.183333333333329 * sp[31] + 0.1416666666666669 * sp[34] + -0.8375000000000079 * sp[35] + 0.5125000000000043 * sp[29] + -0.4666666666666677 * sp[32] + 0.1083333333333332 * sp[28] + 1.145833333333343 * sp[29] + -0.6375000000000078 * sp[26] + 0.4000000000000106 * sp[27] + 0.1083333333333295 * sp[31] + 0.1083333333333405 * sp[32] + 0.1083333333333251 * sp[27] + 0.09166666666667667 * sp[30];
    A[6] = -1.091666666666672 * sp[33] + -1.108333333333342 * sp[34] + -1.108333333333334 * sp[28] + -1.108333333333335 * sp[31] + -0.7333333333333434 * sp[34] + -0.3624999999999929 * sp[35] + -1.479166666666683 * sp[29] + -1.10833333333334 * sp[32] + 2.133333333333349 * sp[28] + 1.154166666666655 * sp[29] + 3.17083333333335 * sp[26] + 2.191666666666671 * sp[27] + 1.150000000000004 * sp[31] + 1.116666666666665 * sp[32] + 1.150000000000003 * sp[27] + 1.008333333333334 * sp[30];
    A[7] = 2.600000000000011 * sp[33] + 1.216666666666669 * sp[34] + 1.216666666666668 * sp[28] + 1.216666666666663 * sp[31] + 1.466666666666684 * sp[34] + 0.3083333333333383 * sp[35] + 2.375000000000027 * sp[29] + 1.216666666666679 * sp[32] + -4.933333333333361 * sp[28] + -1.058333333333329 * sp[29] + -7.258333333333372 * sp[26] + -3.383333333333336 * sp[27] + -2.133333333333335 * sp[31] + -0.8999999999999994 * sp[32] + -2.133333333333336 * sp[27] + -1.266666666666664 * sp[30];
    A[8] = -1.508333333333341 * sp[33] + 0.3083333333333438 * sp[34] + 0.3083333333333331 * sp[28] + 0.3083333333333442 * sp[31] + -0.7333333333333406 * sp[34] + 0.7625000000000099 * sp[35] + -1.187500000000013 * sp[29] + 0.3083333333333413 * sp[32] + 2.800000000000013 * sp[28] + -2.887500000000012 * sp[29] + 4.29583333333336 * sp[26] + -1.391666666666682 * sp[27] + 0.9833333333333312 * sp[31] + -0.7166666666666639 * sp[32] + 0.9833333333333367 * sp[27] + -0.4083333333333348 * sp[30];
    A[9] = 1.649915822768633 * sp[33] + 0.4714045207910287 * sp[34] + -5.185449728701353 * sp[28] + -5.185449728701375 * sp[31] + 3.064129385141738 * sp[34] + 1.767766952966348 * sp[35] + -3.889087296526057 * sp[29] + -5.185449728701424 * sp[32] + -1.649915822768627 * sp[28] + 5.0675985985036 * sp[29] + 10.72445284799601 * sp[26] + 17.44196726926824 * sp[27] + -1.649915822768631 * sp[31] + -0.2357022603955423 * sp[32] + 4.006938426723767 * sp[27] + 5.892556509887891 * sp[30];
    A[10] = 10.96965511460291 * sp[33] + 0.7216878364869765 * sp[34] + -10.53664241271068 * sp[28] + -10.53664241271073 * sp[31] + 0.1443375672973231 * sp[34] + -1.732050807568897 * sp[35] + -8.660254037844483 * sp[29] + -10.53664241271079 * sp[32] + 0.7216878364871026 * sp[28] + 11.54700538379249 * sp[29] + 18.47520861406809 * sp[26] + 29.30052616137364 * sp[27] + 0.7216878364870889 * sp[31] + 5.051814855409215 * sp[32] + 7.649891066762549 * sp[27] + 10.9696551146029 * sp[30];
    A[11] = -6.83333333333332 * sp[33] + 1.583333333333359 * sp[34] + 0.08333333333333703 * sp[28] + 0.08333333333335347 * sp[31] + 2.416666666666691 * sp[34] + 3.749999999999999 * sp[35] + -1.250000000000007 * sp[29] + 0.08333333333339676 * sp[32] + 0.08333333333332457 * sp[28] + -4.916666666666637 * sp[29] + -5.916666666666677 * sp[26] + -10.91666666666673 * sp[27] + 0.08333333333329346 * sp[31] + 0.5833333333333677 * sp[32] + -0.9166666666666496 * sp[27] + -1.83333333333332 * sp[30];
    A[12] = 5.892556509887874 * sp[33] + -1.649915822768609 * sp[34] + 16.73486048808164 * sp[28] + 4.006938426723789 * sp[31] + -3.299831645537254 * sp[34] + -2.474873734152928 * sp[35] + 3.1819805153395 * sp[29] + 4.006938426723837 * sp[32] + 0.4714045207910518 * sp[28] + -2.003469213361901 * sp[29] + -7.660323462854275 * sp[26] + -10.13519719700727 * sp[27] + 0.4714045207910752 * sp[31] + 0.4714045207910343 * sp[32] + -5.185449728701318 * sp[27] + -4.006938426723797 * sp[30];
    A[13] = -16.88749537379662 * sp[33] + -7.361215932167756 * sp[34] + -7.361215932167761 * sp[28] + 3.897114317029959 * sp[31] + -5.196152422706676 * sp[34] + -6.278684177437277 * sp[35] + 4.979646071760504 * sp[29] + 3.897114317029938 * sp[32] + 5.196152422706658 * sp[28] + 11.90784930203618 * sp[29] + -21.86714144555712 * sp[26] + -15.1554445662276 * sp[27] + 5.196152422706625 * sp[31] + 5.196152422706669 * sp[32] + -1.732050807568864 * sp[27] + -3.897114317029913 * sp[30];
    A[14] = 10.41666666666663 * sp[33] + -2.916666666666666 * sp[34] + 10.08333333333331 * sp[28] + -1.41666666666667 * sp[31] + -5.833333333333385 * sp[34] + -4.375000000000012 * sp[35] + -2.875000000000033 * sp[29] + -1.416666666666769 * sp[32] + 0.8333333333333558 * sp[28] + -3.541666666666703 * sp[29] + 7.958333333333417 * sp[26] + 3.583333333333353 * sp[27] + 0.8333333333334065 * sp[31] + 0.8333333333333348 * sp[32] + 1.833333333333387 * sp[27] + 2.916666666666667 * sp[30];
    A[15] = -2.016666666666666 * sp[33] + 0.2833333333333347 * sp[34] + 0.2166666666666655 * sp[28] + 0.2166666666666593 * sp[31] + 1.116666666666661 * sp[34] + -0.8000000000000096 * sp[35] + 1.666666666666683 * sp[29] + 0.2166666666666752 * sp[32] + -0.6166666666666658 * sp[28] + sp[29] + -3.466666666666693 * sp[26] + -0.7166666666666717 * sp[27] + -0.6166666666666784 * sp[31] + -0.6166666666666797 * sp[32] + 2.783333333333351 * sp[27] + 0.8166666666666658 * sp[30];
    A[16] = 2.533333333333332 * sp[33] + -1.733333333333336 * sp[34] + 0.7333333333333353 * sp[28] + 0.7333333333333469 * sp[31] + -1.733333333333336 * sp[34] + 2.766666666666671 * sp[35] + -2.166666666666675 * sp[29] + 0.7333333333333444 * sp[32] + 0.7333333333333353 * sp[28] + -2.166666666666675 * sp[29] + 2.766666666666684 * sp[26] + -1.733333333333343 * sp[27] + 0.7333333333333469 * sp[31] + 0.7333333333333444 * sp[32] + -1.733333333333343 * sp[27] + 2.533333333333341 * sp[30];
    A[17] = 0.8166666666666687 * sp[33] + 2.78333333333334 * sp[34] + -0.6166666666666714 * sp[28] + -0.6166666666666724 * sp[31] + -0.7166666666666737 * sp[34] + -3.466666666666687 * sp[35] + sp[29] + -0.6166666666666742 * sp[32] + 0.2166666666666691 * sp[28] + 1.666666666666676 * sp[29] + -0.8000000000000097 * sp[26] + 1.116666666666671 * sp[27] + 0.2166666666666712 * sp[31] + 0.2166666666666683 * sp[32] + 0.2833333333333358 * sp[27] + -2.016666666666676 * sp[30];
    A[18] = -0.06666666666666932 * sp[33] + -0.9500000000000043 * sp[34] + 0.3166666666666703 * sp[28] + -0.9499999999999938 * sp[31] + 0.4666666666666803 * sp[34] + 1.258333333333354 * sp[35] + -0.1083333333333304 * sp[29] + 0.6833333333333415 * sp[32] + 0.03333333333332855 * sp[28] + -0.7083333333333465 * sp[29] + 0.8583333333333288 * sp[26] + 0.1166666666666598 * sp[27] + 0.03333333333333302 * sp[31] + 0.03333333333333852 * sp[32] + 0.03333333333332261 * sp[27] + -0.1833333333333418 * sp[30];
    A[19] = 1.633333333333336 * sp[33] + 3.066666666666675 * sp[34] + 1.199999999999992 * sp[28] + 3.066666666666666 * sp[31] + -1.433333333333347 * sp[34] + -3.683333333333359 * sp[35] + -0.2833333333333345 * sp[29] + -2.533333333333331 * sp[32] + 0.4333333333333383 * sp[28] + 1.583333333333345 * sp[29] + -0.2166666666666617 * sp[26] + 0.9333333333333431 * sp[27] + 0.4333333333333426 * sp[31] + 0.4333333333333376 * sp[32] + 0.4333333333333486 * sp[27] + 1.200000000000024 * sp[30];
    A[20] = 1.266666666666664 * sp[33] + -2.116666666666672 * sp[34] + 2.483333333333334 * sp[28] + -2.116666666666669 * sp[31] + -0.8666666666666663 * sp[34] + 3.008333333333341 * sp[35] + -2.025000000000007 * sp[29] + 1.849999999999992 * sp[32] + 0.3666666666666666 * sp[28] + -1.95833333333334 * sp[29] + 1.275000000000007 * sp[26] + -1.050000000000007 * sp[27] + 0.366666666666673 * sp[31] + 0.3666666666666709 * sp[32] + 0.3666666666666742 * sp[27] + -1.016666666666665 * sp[30];
    A[21] = 0.1833333333333388 * sp[33] + -0.03333333333332042 * sp[34] + -0.03333333333333838 * sp[28] + -0.03333333333333405 * sp[31] + -0.1166666666666603 * sp[34] + -0.8583333333333524 * sp[35] + 0.7083333333333528 * sp[29] + -0.03333333333332922 * sp[32] + -0.6833333333333468 * sp[28] + 0.1083333333333353 * sp[29] + -1.258333333333347 * sp[26] + -0.4666666666666719 * sp[27] + 0.949999999999998 * sp[31] + -0.3166666666666943 * sp[32] + 0.9500000000000062 * sp[27] + 0.06666666666666035 * sp[30];
    A[22] = -1.200000000000005 * sp[33] + -0.4333333333333349 * sp[34] + -0.4333333333333302 * sp[28] + -0.4333333333333275 * sp[31] + -0.9333333333333422 * sp[34] + 0.2166666666666643 * sp[35] + -1.583333333333357 * sp[29] + -0.4333333333333457 * sp[32] + 2.533333333333357 * sp[28] + 0.2833333333333329 * sp[29] + 3.683333333333362 * sp[26] + 1.43333333333334 * sp[27] + -3.066666666666676 * sp[31] + -1.199999999999985 * sp[32] + -3.066666666666686 * sp[27] + -1.633333333333328 * sp[30];
    A[23] = 1.016666666666668 * sp[33] + -0.3666666666666806 * sp[34] + -0.366666666666668 * sp[28] + -0.3666666666666788 * sp[31] + 1.050000000000001 * sp[34] + -1.275000000000012 * sp[35] + 1.958333333333342 * sp[29] + -0.366666666666672 * sp[32] + -1.85000000000001 * sp[28] + 2.025000000000009 * sp[29] + -3.008333333333352 * sp[26] + 0.8666666666666747 * sp[27] + 2.116666666666676 * sp[31] + -2.48333333333334 * sp[32] + 2.116666666666678 * sp[27] + -1.266666666666674 * sp[30];
    A[24] = 3.77123616632826 * sp[33] + 6.128258770283434 * sp[34] + 3.299831645537219 * sp[28] + 3.299831645537242 * sp[31] + -3.771236166328296 * sp[34] + 1.178511301977601 * sp[35] + -1.649915822768568 * sp[29] + 3.299831645537291 * sp[32] + 0.9428090415820782 * sp[28] + -5.421151989096851 * sp[29] + -2.592724864350705 * sp[26] + -8.956685895029651 * sp[27] + 0.9428090415820819 * sp[31] + 12.25651754056687 * sp[32] + 3.77123616632828 * sp[27] + 11.7851130197758 * sp[30];
    A[25] = -8.94892917243917 * sp[33] + -1.44337567297397 * sp[34] + 3.75277674973255 * sp[28] + 3.752776749732607 * sp[31] + -3.175426480542803 * sp[34] + 2.020725942163686 * sp[35] + -1.443375672973957 * sp[29] + 3.752776749732665 * sp[32] + 1.443375672974014 * sp[28] + -7.216878364870327 * sp[29] + -3.752776749732625 * sp[26] + -12.41303078757705 * sp[27] + 1.44337567297395 * sp[31] + 10.10362971081832 * sp[32] + 4.907477288111856 * sp[27] + 14.14508159514584 * sp[30];
    A[26] = 11.16666666666668 * sp[33] + 1.833333333333341 * sp[34] + -5.166666666666692 * sp[28] + -5.166666666666687 * sp[31] + -8.16666666666671 * sp[34] + -16.66666666666671 * sp[35] + 3.333333333333385 * sp[29] + -5.166666666666739 * sp[32] + 3.166666666666682 * sp[28] + 10.66666666666666 * sp[29] + 2.66666666666666 * sp[26] + 10.1666666666667 * sp[27] + 3.16666666666673 * sp[31] + -7.833333333333409 * sp[32] + -4.833333333333356 * sp[27] + -17.16666666666673 * sp[30];
    A[27] = -11.78511301977579 * sp[33] + -3.771236166328269 * sp[34] + -12.25651754056681 * sp[28] + -0.9428090415820524 * sp[31] + 8.956685895029649 * sp[34] + 2.592724864350735 * sp[35] + 5.421151989096827 * sp[29] + -0.9428090415821058 * sp[32] + -3.299831645537243 * sp[28] + 1.649915822768599 * sp[29] + -1.178511301977565 * sp[26] + 3.771236166328302 * sp[27] + -3.299831645537283 * sp[31] + -3.299831645537264 * sp[32] + -6.128258770283466 * sp[27] + -3.77123616632829 * sp[30];
    A[28] = 7.794228634059974 * sp[33] + 1.732050807568875 * sp[34] + 1.732050807568886 * sp[28] + -3.464101615137751 * sp[31] + -2.598076211353278 * sp[34] + -0.433012701892129 * sp[35] + -5.629165124598755 * sp[29] + -3.464101615137691 * sp[32] + 2.598076211353308 * sp[28] + -2.165063509461179 * sp[29] + 13.42339375865882 * sp[26] + 8.660254037844366 * sp[27] + 2.598076211353373 * sp[31] + 2.598076211353393 * sp[32] + -0.8660254037845494 * sp[27] + -5.196152422706595 * sp[30];
    A[29] = -20.83333333333333 * sp[33] + -6.66666666666668 * sp[34] + -12.66666666666664 * sp[28] + 0.3333333333333609 * sp[31] + 15.83333333333341 * sp[34] + 4.583333333333425 * sp[35] + 11.58333333333335 * sp[29] + 0.3333333333335431 * sp[32] + -5.833333333333364 * sp[28] + 2.916666666666657 * sp[29] + -10.08333333333339 * sp[26] + -1.333333333333366 * sp[27] + -5.833333333333445 * sp[31] + -5.833333333333408 * sp[32] + 2.166666666666613 * sp[27] + 13.33333333333324 * sp[30];
    A[30] = -0.03333333333333005 * sp[33] + 0.4416666666666715 * sp[34] + -0.1916666666666688 * sp[28] + -0.1916666666666705 * sp[31] + -0.8916666666666634 * sp[34] + 1.27500000000001 * sp[35] + -0.7916666666666742 * sp[29] + -0.1916666666666747 * sp[32] + -0.1916666666666666 * sp[28] + -0.7916666666666754 * sp[29] + 1.275000000000011 * sp[26] + 0.4416666666666704 * sp[27] + -0.1916666666666629 * sp[31] + -0.1916666666666607 * sp[32] + -0.8916666666666752 * sp[27] + -0.03333333333333155 * sp[30];
    A[31] = 0.8166666666666687 * sp[33] + -0.7166666666666737 * sp[34] + 0.2166666666666691 * sp[28] + 0.2166666666666712 * sp[31] + 2.78333333333334 * sp[34] + -3.466666666666687 * sp[35] + 1.666666666666676 * sp[29] + 0.2166666666666683 * sp[32] + -0.6166666666666714 * sp[28] + sp[29] + -0.8000000000000097 * sp[26] + 0.2833333333333358 * sp[27] + -0.6166666666666724 * sp[31] + -0.6166666666666742 * sp[32] + 1.116666666666671 * sp[27] + -2.016666666666676 * sp[30];
    A[32] = 0.6333333333333383 * sp[33] + 1.691666666666679 * sp[34] + -0.6083333333333383 * sp[28] + -0.6083333333333372 * sp[31] + 1.691666666666679 * sp[34] + 6.191666666666705 * sp[35] + -1.875000000000014 * sp[29] + -0.6083333333333311 * sp[32] + -0.6083333333333383 * sp[28] + -1.875000000000014 * sp[29] + 0.8583333333333396 * sp[26] + 0.3583333333333324 * sp[27] + -0.6083333333333372 * sp[31] + -0.6083333333333311 * sp[32] + 0.3583333333333324 * sp[27] + 2.633333333333346 * sp[30];
    A[33] = -1.008333333333341 * sp[33] + -1.150000000000007 * sp[34] + -1.116666666666674 * sp[28] + -1.150000000000004 * sp[31] + -2.191666666666683 * sp[34] + -3.170833333333353 * sp[35] + -1.154166666666679 * sp[29] + -2.133333333333344 * sp[32] + 1.108333333333339 * sp[28] + 1.479166666666675 * sp[29] + 0.3625000000000069 * sp[26] + 0.7333333333333395 * sp[27] + 1.108333333333334 * sp[31] + 1.108333333333329 * sp[32] + 1.108333333333343 * sp[27] + 1.09166666666667 * sp[30];
    A[34] = 1.266666666666675 * sp[33] + 2.133333333333347 * sp[34] + 0.9000000000000019 * sp[28] + 2.13333333333334 * sp[31] + 3.383333333333353 * sp[34] + 7.258333333333375 * sp[35] + 1.058333333333336 * sp[29] + 4.933333333333346 * sp[32] + -1.216666666666675 * sp[28] + -2.375000000000015 * sp[29] + -0.3083333333333387 * sp[26] + -1.466666666666677 * sp[27] + -1.216666666666673 * sp[31] + -1.216666666666666 * sp[32] + -1.216666666666676 * sp[27] + -2.600000000000015 * sp[30];
    A[35] = 0.4083333333333337 * sp[33] + -0.9833333333333421 * sp[34] + 0.7166666666666691 * sp[28] + -0.9833333333333405 * sp[31] + 1.391666666666668 * sp[34] + -4.295833333333358 * sp[35] + 2.88750000000001 * sp[29] + -2.800000000000014 * sp[32] + -0.3083333333333351 * sp[28] + 1.187500000000013 * sp[29] + -0.7625000000000061 * sp[26] + 0.7333333333333467 * sp[27] + -0.3083333333333358 * sp[31] + -0.3083333333333381 * sp[32] + -0.3083333333333361 * sp[27] + 1.508333333333336 * sp[30];
    A[36] = -0.5083333333333333 * sp[33] + -0.6916666666666634 * sp[34] + -0.6916666666666722 * sp[28] + -0.6916666666666695 * sp[31] + 0.2666666666666687 * sp[34] + 1.095833333333354 * sp[35] + -1.520833333333348 * sp[29] + -0.6916666666666665 * sp[32] + 0.4666666666666712 * sp[28] + 0.1124999999999977 * sp[29] + 1.29583333333334 * sp[26] + 0.9416666666666689 * sp[27] + 0.6499999999999998 * sp[31] + 2.283333333333355 * sp[32] + 0.649999999999996 * sp[27] + 1.591666666666674 * sp[30];
    A[37] = 0.6000000000000036 * sp[33] + 0.383333333333335 * sp[34] + 0.3833333333333365 * sp[28] + 0.3833333333333367 * sp[31] + 0.1333333333333404 * sp[34] + -0.441666666666667 * sp[35] + 0.9583333333333446 * sp[29] + 0.3833333333333408 * sp[32] + -0.9333333333333452 * sp[28] + -0.1416666666666686 * sp[29] + -1.675000000000012 * sp[26] + -0.8833333333333371 * sp[27] + 0.5333333333333377 * sp[31] + 0.09999999999999121 * sp[32] + 0.5333333333333454 * sp[27] + 0.06666666666666354 * sp[30];
    A[38] = -0.09166666666666939 * sp[33] + -0.1083333333333387 * sp[34] + -0.1083333333333343 * sp[28] + -0.1083333333333368 * sp[31] + -0.4000000000000067 * sp[34] + 0.6374999999999981 * sp[35] + -1.14583333333334 * sp[29] + -0.1083333333333368 * sp[32] + 0.4666666666666737 * sp[28] + -0.5125 * sp[29] + 0.8375000000000088 * sp[26] + -0.1416666666666683 * sp[27] + -1.183333333333336 * sp[31] + 2.116666666666679 * sp[32] + -1.18333333333334 * sp[27] + 1.00833333333334 * sp[30];
    A[39] = 4.006938426723798 * sp[33] + 5.185449728701378 * sp[34] + -0.4714045207910356 * sp[28] + -0.4714045207910317 * sp[31] + 10.13519719700725 * sp[34] + 7.660323462854293 * sp[35] + 2.003469213361877 * sp[29] + -0.4714045207910549 * sp[32] + -4.006938426723797 * sp[28] + -3.181980515339481 * sp[29] + 2.474873734152925 * sp[26] + 3.299831645537243 * sp[27] + -4.006938426723785 * sp[31] + -16.73486048808168 * sp[32] + 1.649915822768593 * sp[27] + -5.892556509887909 * sp[30];
    A[40] = -0.5773502691895994 * sp[33] + -0.7216878364869961 * sp[34] + -3.319764047840375 * sp[28] + -3.319764047840355 * sp[31] + 4.474464586219613 * sp[34] + 4.041451884327452 * sp[35] + -2.886751345948183 * sp[29] + -3.319764047840363 * sp[32] + -0.7216878364870354 * sp[28] + 6.928203230275534 * sp[26] + 7.649891066762579 * sp[27] + -0.7216878364870181 * sp[31] + -5.051814855409171 * sp[32] + 6.206515393788455 * sp[27] + -0.5773502691896271 * sp[30];
    A[41] = 4.833333333333365 * sp[33] + 2.41666666666669 * sp[34] + -4.083333333333362 * sp[28] + -4.083333333333348 * sp[31] + 14.91666666666675 * sp[34] + 22.91666666666678 * sp[35] + -12.08333333333341 * sp[29] + -4.083333333333296 * sp[32] + -4.083333333333373 * sp[28] + -5.75000000000002 * sp[29] + 3.250000000000015 * sp[26] + 1.583333333333316 * sp[27] + -4.083333333333373 * sp[31] + 11.41666666666674 * sp[32] + 4.916666666666677 * sp[27] + 19.83333333333341 * sp[30];
    A[42] = -5.892556509887928 * sp[33] + -4.00693842672379 * sp[34] + 0.2357022603955388 * sp[28] + 1.649915822768634 * sp[31] + -17.44196726926826 * sp[34] + -10.72445284799604 * sp[35] + -5.067598598503555 * sp[29] + 1.649915822768649 * sp[32] + 5.18544972870139 * sp[28] + 3.88908729652602 * sp[29] + -1.767766952966376 * sp[26] + -3.064129385141744 * sp[27] + 5.185449728701384 * sp[31] + 5.18544972870137 * sp[32] + -0.4714045207910136 * sp[27] + -1.649915822768604 * sp[30];
    A[43] = -3.897114317029996 * sp[33] + -3.031088913245559 * sp[34] + -3.031088913245561 * sp[28] + -0.4330127018922304 * sp[31] + -5.196152422706642 * sp[34] + -4.113620667976122 * sp[35] + -1.515544456622848 * sp[29] + -0.4330127018922533 * sp[32] + 5.196152422706636 * sp[28] + 5.412658773652778 * sp[29] + -2.381569860407204 * sp[26] + -2.165063509461083 * sp[27] + 5.196152422706606 * sp[31] + 5.196152422706595 * sp[32] + -1.732050807568826 * sp[27] + 0.4330127018921799 * sp[30];
    A[44] = -10.41666666666672 * sp[33] + -7.083333333333361 * sp[34] + -4.083333333333338 * sp[28] + -0.5833333333333198 * sp[31] + -30.83333333333347 * sp[34] + -18.95833333333342 * sp[35] + -12.45833333333336 * sp[29] + -0.5833333333333895 * sp[32] + 9.166666666666737 * sp[28] + 6.875000000000005 * sp[29] + 3.375000000000049 * sp[26] + 1.083333333333323 * sp[27] + 9.166666666666728 * sp[31] + 9.1666666666667 * sp[32] + 0.1666666666666941 * sp[27] + -12.91666666666668 * sp[30];
    A[45] = -1.591666666666672 * sp[33] + -0.9416666666666754 * sp[34] + 0.6916666666666702 * sp[28] + 0.6916666666666687 * sp[31] + -0.6500000000000026 * sp[34] + -1.295833333333347 * sp[35] + 1.52083333333335 * sp[29] + 0.691666666666673 * sp[32] + -2.283333333333345 * sp[28] + -0.1125000000000024 * sp[29] + -1.095833333333333 * sp[26] + 0.6916666666666694 * sp[27] + -0.6500000000000101 * sp[31] + -0.4666666666666724 * sp[32] + -0.2666666666666608 * sp[27] + 0.5083333333333396 * sp[30];
    A[46] = -0.06666666666666932 * sp[33] + 0.4666666666666803 * sp[34] + 0.03333333333332855 * sp[28] + 0.03333333333333302 * sp[31] + -0.9500000000000043 * sp[34] + 1.258333333333354 * sp[35] + -0.7083333333333465 * sp[29] + 0.03333333333333852 * sp[32] + 0.3166666666666703 * sp[28] + -0.1083333333333304 * sp[29] + 0.8583333333333288 * sp[26] + 0.03333333333332261 * sp[27] + -0.9499999999999938 * sp[31] + 0.6833333333333415 * sp[32] + 0.1166666666666598 * sp[27] + -0.1833333333333418 * sp[30];
    A[47] = -1.008333333333341 * sp[33] + -2.191666666666683 * sp[34] + 1.108333333333339 * sp[28] + 1.108333333333334 * sp[31] + -1.150000000000007 * sp[34] + -3.170833333333353 * sp[35] + 1.479166666666675 * sp[29] + 1.108333333333329 * sp[32] + -1.116666666666674 * sp[28] + -1.154166666666679 * sp[29] + 0.3625000000000069 * sp[26] + 1.108333333333343 * sp[27] + -1.150000000000004 * sp[31] + -2.133333333333344 * sp[32] + 0.7333333333333395 * sp[27] + 1.09166666666667 * sp[30];
    A[48] = 2.633333333333342 * sp[33] + 2.275000000000007 * sp[34] + 3.241666666666677 * sp[28] + 2.275000000000007 * sp[31] + 2.275000000000007 * sp[34] + 2.775000000000011 * sp[35] + 1.00833333333334 * sp[29] + 1.508333333333339 * sp[32] + 3.241666666666677 * sp[28] + 1.00833333333334 * sp[29] + 10.04166666666666 * sp[26] + 5.508333333333332 * sp[27] + 2.275000000000007 * sp[31] + 1.508333333333339 * sp[32] + 5.508333333333332 * sp[27] + 3.683333333333329 * sp[30];
    A[49] = -2.016666666666677 * sp[33] + -3.13333333333335 * sp[34] + -1.400000000000004 * sp[28] + -3.133333333333338 * sp[31] + -2.300000000000011 * sp[34] + -4.216666666666686 * sp[35] + -0.6833333333333371 * sp[29] + -2.600000000000005 * sp[32] + -2.233333333333341 * sp[28] + -1.683333333333348 * sp[29] + -5.083333333333321 * sp[26] + -7.933333333333325 * sp[27] + -2.300000000000004 * sp[31] + -2.766666666666677 * sp[32] + -3.433333333333322 * sp[27] + -5.866666666666656 * sp[30];
    A[50] = -0.0333333333333348 * sp[33] + 0.8583333333333472 * sp[34] + 0.1583333333333294 * sp[28] + 0.8583333333333463 * sp[31] + -0.4750000000000013 * sp[34] + 1.691666666666686 * sp[35] + -1.075000000000006 * sp[29] + 1.091666666666683 * sp[32] + 0.158333333333334 * sp[28] + 0.2583333333333375 * sp[29] + 1.624999999999996 * sp[26] + 2.424999999999995 * sp[27] + -0.4749999999999967 * sp[31] + 1.091666666666674 * sp[32] + -0.2416666666666664 * sp[27] + 2.183333333333334 * sp[30];
    A[51] = 1.508333333333332 * sp[33] + 1.816666666666661 * sp[34] + 1.816666666666671 * sp[28] + 1.816666666666667 * sp[31] + 0.7750000000000029 * sp[34] + 0.3208333333333231 * sp[35] + 2.270833333333344 * sp[29] + 1.816666666666668 * sp[32] + 4.30833333333332 * sp[28] + 7.504166666666655 * sp[29] + 0.3208333333333386 * sp[26] + 1.81666666666667 * sp[27] + 2.591666666666657 * sp[31] + 4.308333333333317 * sp[32] + 0.7750000000000059 * sp[27] + 1.508333333333333 * sp[30];
    A[52] = -2.600000000000006 * sp[33] + -1.383333333333333 * sp[34] + -1.383333333333336 * sp[28] + -1.383333333333333 * sp[31] + -1.133333333333348 * sp[34] + -0.2250000000000028 * sp[35] + -2.291666666666683 * sp[29] + -1.38333333333334 * sp[32] + -7.533333333333329 * sp[28] + -5.258333333333323 * sp[29] + 0.9416666666666652 * sp[26] + -1.383333333333331 * sp[27] + -3.933333333333334 * sp[31] + -2.866666666666662 * sp[32] + 0.03333333333332683 * sp[27] + -1.016666666666669 * sp[30];
    A[53] = 1.091666666666673 * sp[33] + -0.01666666666666466 * sp[34] + -0.01666666666666461 * sp[28] + -0.01666666666666781 * sp[31] + 0.3583333333333445 * sp[34] + -0.3875000000000005 * sp[35] + 0.7291666666666783 * sp[29] + -0.01666666666666933 * sp[32] + 3.225000000000004 * sp[28] + 0.9624999999999995 * sp[29] + -1.054166666666665 * sp[26] + -0.0166666666666624 * sp[27] + 1.341666666666674 * sp[31] + 0.558333333333338 * sp[32] + -0.3083333333333285 * sp[27] + 0.09166666666667252 * sp[30];
    A[54] = -7.542472332656546 * sp[33] + -8.720983634634109 * sp[34] + 4.006938426723768 * sp[28] + 4.006938426723774 * sp[31] + -7.778174593052063 * sp[34] + -8.249579113843055 * sp[35] + 4.478342947514816 * sp[29] + 4.00693842672381 * sp[32] + -8.720983634634116 * sp[28] + -12.9636243217534 * sp[29] + -0.2357022603955219 * sp[26] + 4.006938426723742 * sp[27] + -7.778174593052043 * sp[31] + -11.07800623858925 * sp[32] + 0.235702260395517 * sp[27] + 2.357022603955149 * sp[30];
    A[55] = -5.917840259193718 * sp[33] + 0.721687836486999 * sp[34] + 11.98001808568475 * sp[28] + 11.98001808568475 * sp[31] + -0.8660254037844548 * sp[34] + -2.237232293109827 * sp[35] + 13.35122497501014 * sp[29] + 11.98001808568479 * sp[32] + -11.83568051838745 * sp[28] + 18.25870226312184 * sp[29] + 2.670244995002045 * sp[26] + 11.98001808568472 * sp[27] + -0.8660254037845543 * sp[31] + 10.96965511460279 * sp[32] + 4.041451884327407 * sp[27] + 8.804591605141777 * sp[30];
    A[56] = -3.583333333333381 * sp[33] + -4.916666666666716 * sp[34] + 6.583333333333361 * sp[28] + 6.583333333333329 * sp[31] + -7.000000000000052 * sp[34] + -7.708333333333378 * sp[35] + 7.291666666666682 * sp[29] + 6.583333333333281 * sp[32] + -2.66666666666671 * sp[28] + 4.458333333333227 * sp[29] + 5.45833333333338 * sp[26] + 6.583333333333385 * sp[27] + -7.000000000000019 * sp[31] + 2.166666666666583 * sp[32] + 6.166666666666693 * sp[27] + 6.916666666666667 * sp[30];
    A[57] = 5.892556509887946 * sp[33] + 7.542472332656521 * sp[34] + -10.84230397819375 * sp[28] + -5.185449728701384 * sp[31] + 9.192388155425171 * sp[34] + 8.367430244040817 * sp[35] + -4.360491817317069 * sp[29] + -5.185449728701411 * sp[32] + 5.421151989096892 * sp[28] + 5.067598598503625 * sp[29] + -18.97403196183906 * sp[26] + -5.185449728701346 * sp[27] + 9.192388155425123 * sp[31] + 5.892556509887903 * sp[32] + -6.835365551470012 * sp[27] + -4.006938426723791 * sp[30];
    A[58] = 16.88749537379659 * sp[33] + 9.526279441628855 * sp[34] + 9.526279441628857 * sp[28] + -1.73205080756885 * sp[31] + 11.69134295108993 * sp[34] + 10.60881119635943 * sp[35] + -0.649519052838321 * sp[29] + -1.732050807568852 * sp[32] + 22.08364779650326 * sp[28] + 2.81458256229944 * sp[29] + 36.58957330989253 * sp[26] + -1.732050807568892 * sp[27] + 11.69134295108996 * sp[31] + 3.897114317029994 * sp[32] + 19.48557158514986 * sp[27] + 0.4330127018922139 * sp[30];
    A[59] = 10.41666666666675 * sp[33] + 13.33333333333335 * sp[34] + 0.3333333333333535 * sp[28] + 1.833333333333299 * sp[31] + 16.25000000000009 * sp[34] + 14.79166666666665 * sp[35] + 3.291666666666715 * sp[29] + 1.833333333333328 * sp[32] + 9.583333333333385 * sp[28] + 8.958333333333391 * sp[29] + 7.458333333333296 * sp[26] + 1.833333333333275 * sp[27] + 16.25000000000001 * sp[31] + 10.41666666666667 * sp[32] + 9.416666666666629 * sp[27] + 2.916666666666611 * sp[30];
    A[60] = -0.06666666666666232 * sp[33] + 0.8833333333333417 * sp[34] + -0.3833333333333367 * sp[28] + -0.3833333333333399 * sp[31] + -0.5333333333333303 * sp[34] + 1.675000000000012 * sp[35] + -0.9583333333333418 * sp[29] + -0.3833333333333421 * sp[32] + -0.09999999999999176 * sp[28] + 0.1416666666666702 * sp[29] + 0.4416666666666616 * sp[26] + -0.3833333333333407 * sp[27] + -0.5333333333333297 * sp[31] + 0.9333333333333309 * sp[32] + -0.1333333333333339 * sp[27] + -0.600000000000008 * sp[30];
    A[61] = 1.633333333333336 * sp[33] + -1.433333333333347 * sp[34] + 0.4333333333333383 * sp[28] + 0.4333333333333426 * sp[31] + 3.066666666666675 * sp[34] + -3.683333333333359 * sp[35] + 1.583333333333345 * sp[29] + 0.4333333333333376 * sp[32] + 1.199999999999992 * sp[28] + -0.2833333333333345 * sp[29] + -0.2166666666666617 * sp[26] + 0.4333333333333486 * sp[27] + 3.066666666666666 * sp[31] + -2.533333333333331 * sp[32] + 0.9333333333333431 * sp[27] + 1.200000000000024 * sp[30];
    A[62] = 1.266666666666675 * sp[33] + 3.383333333333353 * sp[34] + -1.216666666666675 * sp[28] + -1.216666666666673 * sp[31] + 2.133333333333347 * sp[34] + 7.258333333333375 * sp[35] + -2.375000000000015 * sp[29] + -1.216666666666666 * sp[32] + 0.9000000000000019 * sp[28] + 1.058333333333336 * sp[29] + -0.3083333333333387 * sp[26] + -1.216666666666676 * sp[27] + 2.13333333333334 * sp[31] + 4.933333333333346 * sp[32] + -1.466666666666677 * sp[27] + -2.600000000000015 * sp[30];
    A[63] = -2.016666666666677 * sp[33] + -2.300000000000011 * sp[34] + -2.233333333333341 * sp[28] + -2.300000000000004 * sp[31] + -3.13333333333335 * sp[34] + -4.216666666666686 * sp[35] + -1.683333333333348 * sp[29] + -2.766666666666677 * sp[32] + -1.400000000000004 * sp[28] + -0.6833333333333371 * sp[29] + -5.083333333333321 * sp[26] + -3.433333333333322 * sp[27] + -3.133333333333338 * sp[31] + -2.600000000000005 * sp[32] + -7.933333333333325 * sp[27] + -5.866666666666656 * sp[30];
    A[64] = 2.533333333333347 * sp[33] + 4.26666666666669 * sp[34] + 1.800000000000001 * sp[28] + 4.266666666666675 * sp[31] + 4.26666666666669 * sp[34] + 8.766666666666712 * sp[35] + 1.36666666666667 * sp[29] + 5.866666666666683 * sp[32] + 1.800000000000001 * sp[28] + 1.36666666666667 * sp[29] + 3.833333333333317 * sp[26] + 5.86666666666665 * sp[27] + 4.266666666666675 * sp[31] + 5.866666666666683 * sp[32] + 5.86666666666665 * sp[27] + 11.73333333333333 * sp[30];
    A[65] = 0.8166666666666671 * sp[33] + -1.966666666666682 * sp[34] + 1.433333333333339 * sp[28] + -1.96666666666668 * sp[31] + 1.533333333333335 * sp[34] + -4.716666666666699 * sp[35] + 3.150000000000011 * sp[29] + -3.100000000000025 * sp[32] + 0.5999999999999959 * sp[28] + -0.5166666666666668 * sp[29] + 0.4166666666666661 * sp[26] + -2.433333333333326 * sp[27] + 1.533333333333331 * sp[31] + -3.266666666666669 * sp[32] + 2.066666666666674 * sp[27] + -5.866666666666661 * sp[30];
    A[66] = -1.016666666666663 * sp[33] + -1.383333333333323 * sp[34] + -1.383333333333342 * sp[28] + -1.383333333333336 * sp[31] + 0.0333333333333366 * sp[34] + 0.9416666666666884 * sp[35] + -2.29166666666668 * sp[29] + -1.383333333333332 * sp[32] + -2.866666666666655 * sp[28] + -5.258333333333315 * sp[29] + -0.2250000000000059 * sp[26] + -1.383333333333336 * sp[27] + -3.933333333333314 * sp[31] + -7.533333333333314 * sp[32] + -1.133333333333338 * sp[27] + -2.600000000000002 * sp[30];
    A[67] = 1.200000000000002 * sp[33] + 0.7666666666666666 * sp[34] + 0.766666666666671 * sp[28] + 0.766666666666671 * sp[31] + 0.2666666666666757 * sp[34] + -0.383333333333334 * sp[35] + 1.416666666666678 * sp[29] + 0.7666666666666735 * sp[32] + 3.733333333333324 * sp[28] + 3.016666666666659 * sp[29] + -0.3833333333333273 * sp[26] + 0.7666666666666702 * sp[27] + 5.86666666666665 * sp[31] + 3.733333333333321 * sp[32] + 0.2666666666666657 * sp[27] + 1.2 * sp[30];
    A[68] = -0.1833333333333373 * sp[33] + -0.2166666666666773 * sp[34] + -0.216666666666669 * sp[28] + -0.2166666666666737 * sp[31] + -0.3000000000000098 * sp[34] + 0.524999999999993 * sp[35] + -1.041666666666675 * sp[29] + -0.2166666666666719 * sp[32] + -0.866666666666667 * sp[28] + -1.008333333333343 * sp[29] + 0.3583333333333298 * sp[26] + -0.2166666666666772 * sp[27] + -1.933333333333332 * sp[31] + -1.533333333333348 * sp[32] + -0.4666666666666712 * sp[27] + -0.6000000000000157 * sp[30];
    A[69] = 8.013876853447581 * sp[33] + 10.37089945740274 * sp[34] + -0.9428090415820651 * sp[28] + -0.9428090415820558 * sp[31] + 13.19932658214896 * sp[34] + 11.78511301977584 * sp[35] + 0.4714045207910298 * sp[29] + -0.9428090415820792 * sp[32] + 5.656854249492385 * sp[28] + 11.7851130197758 * sp[29] + 0.4714045207910273 * sp[26] + -0.9428090415820375 * sp[27] + 13.19932658214891 * sp[31] + 24.5130350811337 * sp[32] + 1.885618083164153 * sp[27];
    A[70] = -1.154700538379199 * sp[33] + -1.443375672973983 * sp[34] + -6.639528095680731 * sp[28] + -6.639528095680689 * sp[31] + 4.618802153517063 * sp[34] + 5.917840259193757 * sp[35] + -7.938566201357402 * sp[29] + -6.639528095680699 * sp[32] + -5.196152422706544 * sp[28] + -14.86676943163274 * sp[29] + -1.010362971081876 * sp[26] + -6.639528095680665 * sp[27] + 4.618802153517104 * sp[31] + -16.16580753730938 * sp[32] + -2.309401076758491 * sp[27] + -10.39230484541319 * sp[30];
    A[71] = 9.666666666666725 * sp[33] + 4.833333333333377 * sp[34] + -8.166666666666714 * sp[28] + -8.166666666666687 * sp[31] + 17.33333333333344 * sp[34] + 24.58333333333346 * sp[35] + -15.41666666666674 * sp[29] + -8.166666666666636 * sp[32] + 7.000000000000005 * sp[28] + -11.41666666666663 * sp[29] + -3.416666666666689 * sp[26] + -8.166666666666705 * sp[27] + 17.3333333333334 * sp[31] + -2.666666666666603 * sp[32] + -10.66666666666673 * sp[27] + -18.00000000000007 * sp[30];
    A[72] = -11.78511301977584 * sp[33] + -8.01387685344757 * sp[34] + 0.4714045207910615 * sp[28] + 3.299831645537259 * sp[31] + -20.74179891480549 * sp[34] + -14.37783788412653 * sp[35] + -3.064129385141671 * sp[29] + 3.299831645537272 * sp[32] + -8.485281374238559 * sp[28] + -3.064129385141712 * sp[29] + 2.59272486435071 * sp[26] + 3.299831645537235 * sp[27] + -20.74179891480543 * sp[31] + -9.428090415820687 * sp[32] + 1.885618083164133 * sp[27] + 5.656854249492365 * sp[30];
    A[73] = -7.794228634059968 * sp[33] + -6.062177826491103 * sp[34] + -6.0621778264911 * sp[28] + -0.8660254037844608 * sp[31] + -10.39230484541327 * sp[34] + -8.227241335952202 * sp[35] + -3.0310889132456 * sp[29] + -0.8660254037844691 * sp[32] + -5.196152422706653 * sp[28] + -1.299038105676681 * sp[29] + -16.8874953737965 * sp[26] + -0.8660254037844297 * sp[27] + -10.39230484541322 * sp[31] + -3.464101615137734 * sp[32] + -17.32050807568876 * sp[27] + 3.464101615137786 * sp[30];
    A[74] = -20.83333333333342 * sp[33] + -14.1666666666667 * sp[34] + -8.166666666666673 * sp[28] + -1.166666666666629 * sp[31] + -36.66666666666683 * sp[34] + -25.41666666666674 * sp[35] + -12.4166666666667 * sp[29] + -1.166666666666665 * sp[32] + -14.99999999999998 * sp[28] + -5.416666666666674 * sp[29] + -12.41666666666661 * sp[26] + -1.166666666666607 * sp[27] + -36.66666666666671 * sp[31] + -16.66666666666674 * sp[32] + -24.66666666666663 * sp[27] + 10.00000000000006 * sp[30];
    A[75] = -1.008333333333331 * sp[33] + 0.1416666666666669 * sp[34] + 0.1083333333333332 * sp[28] + 0.1083333333333295 * sp[31] + 1.18333333333333 * sp[34] + -0.8375000000000079 * sp[35] + 1.145833333333343 * sp[29] + 0.1083333333333405 * sp[32] + -2.116666666666667 * sp[28] + 0.5125000000000043 * sp[29] + -0.6375000000000078 * sp[26] + 0.1083333333333251 * sp[27] + 1.183333333333329 * sp[31] + -0.4666666666666677 * sp[32] + 0.4000000000000106 * sp[27] + 0.09166666666667667 * sp[30];
    A[76] = 1.266666666666664 * sp[33] + -0.8666666666666663 * sp[34] + 0.3666666666666666 * sp[28] + 0.366666666666673 * sp[31] + -2.116666666666672 * sp[34] + 3.008333333333341 * sp[35] + -1.95833333333334 * sp[29] + 0.3666666666666709 * sp[32] + 2.483333333333334 * sp[28] + -2.025000000000007 * sp[29] + 1.275000000000007 * sp[26] + 0.3666666666666742 * sp[27] + -2.116666666666669 * sp[31] + 1.849999999999992 * sp[32] + -1.050000000000007 * sp[27] + -1.016666666666665 * sp[30];
    A[77] = 0.4083333333333337 * sp[33] + 1.391666666666668 * sp[34] + -0.3083333333333351 * sp[28] + -0.3083333333333358 * sp[31] + -0.9833333333333421 * sp[34] + -4.295833333333358 * sp[35] + 1.187500000000013 * sp[29] + -0.3083333333333381 * sp[32] + 0.7166666666666691 * sp[28] + 2.88750000000001 * sp[29] + -0.7625000000000061 * sp[26] + -0.3083333333333361 * sp[27] + -0.9833333333333405 * sp[31] + -2.800000000000014 * sp[32] + 0.7333333333333467 * sp[27] + 1.508333333333336 * sp[30];
    A[78] = -0.0333333333333348 * sp[33] + -0.4750000000000013 * sp[34] + 0.158333333333334 * sp[28] + -0.4749999999999967 * sp[31] + 0.8583333333333472 * sp[34] + 1.691666666666686 * sp[35] + 0.2583333333333375 * sp[29] + 1.091666666666674 * sp[32] + 0.1583333333333294 * sp[28] + -1.075000000000006 * sp[29] + 1.624999999999996 * sp[26] + -0.2416666666666664 * sp[27] + 0.8583333333333463 * sp[31] + 1.091666666666683 * sp[32] + 2.424999999999995 * sp[27] + 2.183333333333334 * sp[30];
    A[79] = 0.8166666666666671 * sp[33] + 1.533333333333335 * sp[34] + 0.5999999999999959 * sp[28] + 1.533333333333331 * sp[31] + -1.966666666666682 * sp[34] + -4.716666666666699 * sp[35] + -0.5166666666666668 * sp[29] + -3.266666666666669 * sp[32] + 1.433333333333339 * sp[28] + 3.150000000000011 * sp[29] + 0.4166666666666661 * sp[26] + 2.066666666666674 * sp[27] + -1.96666666666668 * sp[31] + -3.100000000000025 * sp[32] + -2.433333333333326 * sp[27] + -5.866666666666661 * sp[30];
    A[80] = 0.633333333333331 * sp[33] + -1.058333333333334 * sp[34] + 1.241666666666665 * sp[28] + -1.058333333333333 * sp[31] + -1.058333333333334 * sp[34] + 3.441666666666681 * sp[35] + -2.325000000000008 * sp[29] + 2.175 * sp[32] + 1.241666666666665 * sp[28] + -2.325000000000008 * sp[29] + 2.708333333333335 * sp[26] + -1.825000000000008 * sp[27] + -1.058333333333333 * sp[31] + 2.175 * sp[32] + -1.825000000000008 * sp[27] + 3.683333333333312 * sp[30];
    A[81] = 0.09166666666666894 * sp[33] + -0.01666666666666089 * sp[34] + -0.01666666666666887 * sp[28] + -0.01666666666666695 * sp[31] + -0.3083333333333322 * sp[34] + -1.054166666666688 * sp[35] + 0.7291666666666826 * sp[29] + -0.01666666666666516 * sp[32] + 0.5583333333333309 * sp[28] + 0.9625000000000065 * sp[29] + -0.3875000000000073 * sp[26] + -0.01666666666666922 * sp[27] + 1.341666666666663 * sp[31] + 3.224999999999985 * sp[32] + 0.3583333333333499 * sp[27] + 1.091666666666676 * sp[30];
    A[82] = -0.6000000000000015 * sp[33] + -0.2166666666666666 * sp[34] + -0.2166666666666655 * sp[28] + -0.2166666666666635 * sp[31] + -0.4666666666666699 * sp[34] + 0.3583333333333342 * sp[35] + -1.041666666666682 * sp[29] + -0.2166666666666753 * sp[32] + -1.533333333333327 * sp[28] + -1.00833333333333 * sp[29] + 0.5250000000000102 * sp[26] + -0.2166666666666582 * sp[27] + -1.933333333333328 * sp[31] + -0.8666666666666669 * sp[32] + -0.3000000000000154 * sp[27] + -0.1833333333333476 * sp[30];
    A[83] = 0.5083333333333335 * sp[33] + -0.1833333333333403 * sp[34] + -0.1833333333333332 * sp[28] + -0.1833333333333392 * sp[31] + 0.7750000000000006 * sp[34] + -1.012500000000006 * sp[35] + 1.604166666666673 * sp[29] + -0.1833333333333342 * sp[32] + 0.9749999999999964 * sp[28] + 0.1708333333333231 * sp[29] + -1.012500000000006 * sp[26] + -0.1833333333333414 * sp[27] + 0.5916666666666639 * sp[31] + 0.9749999999999911 * sp[32] + 0.775000000000006 * sp[27] + 0.5083333333333345 * sp[30];
    A[84] = 1.885618083164127 * sp[33] + 3.064129385141714 * sp[34] + 1.649915822768608 * sp[28] + 1.649915822768619 * sp[31] + -5.421151989096912 * sp[34] + -1.17851130197758 * sp[35] + -2.592724864350651 * sp[29] + 1.649915822768651 * sp[32] + 3.064129385141719 * sp[28] + 3.535533905932762 * sp[29] + 2.121320343559633 * sp[26] + 1.649915822768606 * sp[27] + -5.421151989096904 * sp[31] + -13.4350288425444 * sp[32] + -2.121320343559617 * sp[27] + -2.357022603955104 * sp[30];
    A[85] = -4.474464586219581 * sp[33] + -0.7216878364869855 * sp[34] + 1.876388374866273 * sp[28] + 1.876388374866302 * sp[31] + -3.752776749732486 * sp[34] + -0.07216878364874107 * sp[35] + -1.804219591217503 * sp[29] + 1.876388374866333 * sp[32] + -8.948929172439192 * sp[28] + 0.2165063509461669 * sp[29] + 1.94855715851496 * sp[26] + 1.876388374866283 * sp[27] + -3.75277674973246 * sp[31] + 5.19615242270663 * sp[32] + -1.732050807568791 * sp[27] + 1.587713240271555 * sp[30];
    A[86] = 5.58333333333333 * sp[33] + 0.9166666666666663 * sp[34] + -2.583333333333342 * sp[28] + -2.583333333333341 * sp[31] + -10.33333333333339 * sp[34] + -18.95833333333341 * sp[35] + 6.041666666666734 * sp[29] + -2.583333333333382 * sp[32] + 10.66666666666668 * sp[28] + 4.874999999999996 * sp[29] + -4.125000000000018 * sp[26] + -2.583333333333334 * sp[27] + -10.33333333333339 * sp[31] + 0.5 * sp[32] + 4.500000000000062 * sp[27] + 11.08333333333331 * sp[30];
    A[87] = -5.892556509887887 * sp[33] + -1.885618083164132 * sp[34] + -6.128258770283392 * sp[28] + -0.4714045207910257 * sp[31] + 11.54941075938034 * sp[34] + 4.831896338108142 * sp[35] + 6.246109900481143 * sp[29] + -0.4714045207910602 * sp[32] + -11.07800623858926 * sp[28] + -3.181980515339476 * sp[29] + -13.08147545195111 * sp[26] + -0.4714045207910036 * sp[27] + 11.54941075938032 * sp[31] + 3.535533905932828 * sp[32] + 4.949747468305808 * sp[27] + -1.649915822768621 * sp[30];
    A[88] = 3.89711431702998 * sp[33] + 0.8660254037844366 * sp[34] + 0.8660254037844356 * sp[28] + -1.732050807568875 * sp[31] + -1.299038105676636 * sp[34] + -0.216506350946049 * sp[35] + -2.814582562299335 * sp[29] + -1.732050807568823 * sp[32] + 9.093266739736629 * sp[28] + 0.6495190528383099 * sp[29] + 8.443747686898275 * sp[26] + -1.732050807568875 * sp[27] + -1.29903810567663 * sp[31] + -0.4330127018921675 * sp[32] + -2.165063509461003 * sp[27] + -3.897114317029974 * sp[30];
    A[89] = -10.41666666666665 * sp[33] + -3.333333333333336 * sp[34] + -6.333333333333308 * sp[28] + 0.1666666666666781 * sp[31] + 20.41666666666677 * sp[34] + 8.541666666666767 * sp[35] + 12.04166666666667 * sp[29] + 0.1666666666668162 * sp[32] + -19.58333333333335 * sp[28] + -5.625000000000007 * sp[29] + -12.12500000000001 * sp[26] + 0.1666666666666778 * sp[27] + 20.41666666666674 * sp[31] + 6.250000000000144 * sp[32] + 15.24999999999998 * sp[27] + -12.91666666666645 * sp[30];
    A[90] = -1.091666666666672 * sp[33] + -0.7333333333333434 * sp[34] + 2.133333333333349 * sp[28] + 1.150000000000004 * sp[31] + -1.108333333333342 * sp[34] + -0.3624999999999929 * sp[35] + 1.154166666666655 * sp[29] + 1.116666666666665 * sp[32] + -1.108333333333334 * sp[28] + -1.479166666666683 * sp[29] + 3.17083333333335 * sp[26] + 1.150000000000003 * sp[27] + -1.108333333333335 * sp[31] + -1.10833333333334 * sp[32] + 2.191666666666671 * sp[27] + 1.008333333333334 * sp[30];
    A[91] = 0.1833333333333388 * sp[33] + -0.1166666666666603 * sp[34] + -0.6833333333333468 * sp[28] + 0.949999999999998 * sp[31] + -0.03333333333332042 * sp[34] + -0.8583333333333524 * sp[35] + 0.1083333333333353 * sp[29] + -0.3166666666666943 * sp[32] + -0.03333333333333838 * sp[28] + 0.7083333333333528 * sp[29] + -1.258333333333347 * sp[26] + 0.9500000000000062 * sp[27] + -0.03333333333333405 * sp[31] + -0.03333333333332922 * sp[32] + -0.4666666666666719 * sp[27] + 0.06666666666666035 * sp[30];
    A[92] = -0.5083333333333333 * sp[33] + 0.2666666666666687 * sp[34] + 0.4666666666666712 * sp[28] + 0.6499999999999998 * sp[31] + -0.6916666666666634 * sp[34] + 1.095833333333354 * sp[35] + 0.1124999999999977 * sp[29] + 2.283333333333355 * sp[32] + -0.6916666666666722 * sp[28] + -1.520833333333348 * sp[29] + 1.29583333333334 * sp[26] + 0.649999999999996 * sp[27] + -0.6916666666666695 * sp[31] + -0.6916666666666665 * sp[32] + 0.9416666666666689 * sp[27] + 1.591666666666674 * sp[30];
    A[93] = 1.508333333333332 * sp[33] + 0.7750000000000029 * sp[34] + 4.30833333333332 * sp[28] + 2.591666666666657 * sp[31] + 1.816666666666661 * sp[34] + 0.3208333333333231 * sp[35] + 7.504166666666655 * sp[29] + 4.308333333333317 * sp[32] + 1.816666666666671 * sp[28] + 2.270833333333344 * sp[29] + 0.3208333333333386 * sp[26] + 0.7750000000000059 * sp[27] + 1.816666666666667 * sp[31] + 1.816666666666668 * sp[32] + 1.81666666666667 * sp[27] + 1.508333333333333 * sp[30];
    A[94] = -1.016666666666663 * sp[33] + 0.0333333333333366 * sp[34] + -2.866666666666655 * sp[28] + -3.933333333333314 * sp[31] + -1.383333333333323 * sp[34] + 0.9416666666666884 * sp[35] + -5.258333333333315 * sp[29] + -7.533333333333314 * sp[32] + -1.383333333333342 * sp[28] + -2.29166666666668 * sp[29] + -0.2250000000000059 * sp[26] + -1.133333333333338 * sp[27] + -1.383333333333336 * sp[31] + -1.383333333333332 * sp[32] + -1.383333333333336 * sp[27] + -2.600000000000002 * sp[30];
    A[95] = 0.09166666666666894 * sp[33] + -0.3083333333333322 * sp[34] + 0.5583333333333309 * sp[28] + 1.341666666666663 * sp[31] + -0.01666666666666089 * sp[34] + -1.054166666666688 * sp[35] + 0.9625000000000065 * sp[29] + 3.224999999999985 * sp[32] + -0.01666666666666887 * sp[28] + 0.7291666666666826 * sp[29] + -0.3875000000000073 * sp[26] + 0.3583333333333499 * sp[27] + -0.01666666666666695 * sp[31] + -0.01666666666666516 * sp[32] + -0.01666666666666922 * sp[27] + 1.091666666666676 * sp[30];
    A[96] = 3.683333333333327 * sp[33] + 5.508333333333314 * sp[34] + 1.508333333333337 * sp[28] + 2.274999999999999 * sp[31] + 5.508333333333314 * sp[34] + 10.04166666666666 * sp[35] + 1.008333333333323 * sp[29] + 3.241666666666668 * sp[32] + 1.508333333333337 * sp[28] + 1.008333333333323 * sp[29] + 2.775000000000007 * sp[26] + 2.275 * sp[27] + 2.274999999999999 * sp[31] + 3.241666666666668 * sp[32] + 2.275 * sp[27] + 2.633333333333337 * sp[30];
    A[97] = -5.866666666666667 * sp[33] + -3.433333333333324 * sp[34] + -2.76666666666668 * sp[28] + -2.299999999999999 * sp[31] + -7.93333333333331 * sp[34] + -5.083333333333317 * sp[35] + -1.683333333333314 * sp[29] + -2.23333333333332 * sp[32] + -2.600000000000012 * sp[28] + -0.6833333333333321 * sp[29] + -4.216666666666681 * sp[26] + -2.300000000000001 * sp[27] + -3.133333333333334 * sp[31] + -1.399999999999997 * sp[32] + -3.133333333333335 * sp[27] + -2.016666666666664 * sp[30];
    A[98] = 2.183333333333338 * sp[33] + -0.2416666666666678 * sp[34] + 1.091666666666679 * sp[28] + -0.4750000000000011 * sp[31] + 2.424999999999994 * sp[34] + 1.62500000000002 * sp[35] + 0.2583333333333263 * sp[29] + 0.1583333333333461 * sp[32] + 1.091666666666675 * sp[28] + -1.075 * sp[29] + 1.691666666666678 * sp[26] + -0.475000000000006 * sp[27] + 0.8583333333333352 * sp[31] + 0.1583333333333435 * sp[32] + 0.8583333333333358 * sp[27] + -0.03333333333333199 * sp[30];
    A[99] = -4.006938426723764 * sp[33] + -6.835365551469932 * sp[34] + 5.892556509887902 * sp[28] + 9.192388155425117 * sp[31] + -5.185449728701318 * sp[34] + -18.97403196183908 * sp[35] + 5.067598598503549 * sp[29] + 5.421151989096761 * sp[32] + -5.185449728701379 * sp[28] + -4.360491817317047 * sp[29] + 8.36743024404082 * sp[26] + 9.192388155425142 * sp[27] + -5.185449728701361 * sp[31] + -10.84230397819378 * sp[32] + 7.542472332656502 * sp[27] + 5.892556509887878 * sp[30];
    A[100] = 2.742413778650683 * sp[33] + 17.89785834487832 * sp[34] + 10.9696551146029 * sp[28] + 19.9185842870421 * sp[31] + 0.7216878364868693 * sp[34] + 24.75389279150506 * sp[35] + 9.165435523385241 * sp[29] + 19.34123401785235 * sp[32] + 0.7216878364870403 * sp[28] + 2.525907427704577 * sp[29] + 18.11436469582453 * sp[26] + 19.91858428704214 * sp[27] + 0.7216878364869994 * sp[31] + 5.05181485540918 * sp[32] + 16.31014510460692 * sp[27] + 17.46484564298618 * sp[30];
    A[101] = -1.083333333333329 * sp[33] + 12.16666666666665 * sp[34] + -1.83333333333334 * sp[28] + 1.99999999999998 * sp[31] + -2.416666666666636 * sp[34] + 27.95833333333337 * sp[35] + -2.041666666666659 * sp[29] + 14.33333333333348 * sp[32] + -2.416666666666706 * sp[28] + -2.208333333333341 * sp[29] + 1.791666666666675 * sp[26] + 1.99999999999996 * sp[27] + -2.416666666666687 * sp[31] + 8.083333333333385 * sp[32] + 1.583333333333335 * sp[27] + 9.416666666666712 * sp[30];
    A[102] = 2.357022603955142 * sp[33] + 0.2357022603954899 * sp[34] + -11.07800623858925 * sp[28] + -7.778174593052057 * sp[31] + 4.006938426723712 * sp[34] + -0.2357022603955223 * sp[35] + -12.96362432175338 * sp[29] + -8.720983634634052 * sp[32] + 4.006938426723815 * sp[28] + 4.478342947514792 * sp[29] + -8.249579113843055 * sp[26] + -7.778174593052087 * sp[27] + 4.006938426723788 * sp[31] + 4.006938426723761 * sp[32] + -8.720983634634083 * sp[27] + -7.542472332656542 * sp[30];
    A[103] = 10.39230484541328 * sp[33] + 7.361215932167783 * sp[34] + 7.361215932167664 * sp[28] + -6.495190528383258 * sp[31] + 11.69134295108993 * sp[34] + 6.062177826491048 * sp[35] + 12.99038105676653 * sp[29] + -8.227241335952186 * sp[32] + 11.69134295108993 * sp[28] + 12.99038105676665 * sp[29] + -7.794228634059947 * sp[26] + -6.495190528383226 * sp[27] + 11.69134295108992 * sp[31] + 11.69134295108996 * sp[32] + -3.897114317029989 * sp[27] + -6.062177826491047 * sp[30];
    A[104] = 4.166666666666634 * sp[33] + 0.4166666666666234 * sp[34] + 8.416666666666657 * sp[28] + 2.749999999999958 * sp[31] + 7.083333333333233 * sp[34] + -0.4166666666666714 * sp[35] + 13.58333333333324 * sp[29] + -8.916666666666851 * sp[32] + 7.083333333333406 * sp[28] + 7.916666666666639 * sp[29] + 1.916666666666728 * sp[26] + 2.749999999999981 * sp[27] + 7.083333333333359 * sp[31] + 7.083333333333311 * sp[32] + 3.083333333333355 * sp[27] + -3.333333333333425 * sp[30];
    A[105] = 2.600000000000011 * sp[33] + 1.466666666666684 * sp[34] + -4.933333333333361 * sp[28] + -2.133333333333335 * sp[31] + 1.216666666666669 * sp[34] + 0.3083333333333383 * sp[35] + -1.058333333333329 * sp[29] + -0.8999999999999994 * sp[32] + 1.216666666666668 * sp[28] + 2.375000000000027 * sp[29] + -7.258333333333372 * sp[26] + -2.133333333333336 * sp[27] + 1.216666666666663 * sp[31] + 1.216666666666679 * sp[32] + -3.383333333333336 * sp[27] + -1.266666666666664 * sp[30];
    A[106] = -1.200000000000005 * sp[33] + -0.9333333333333422 * sp[34] + 2.533333333333357 * sp[28] + -3.066666666666676 * sp[31] + -0.4333333333333349 * sp[34] + 0.2166666666666643 * sp[35] + 0.2833333333333329 * sp[29] + -1.199999999999985 * sp[32] + -0.4333333333333302 * sp[28] + -1.583333333333357 * sp[29] + 3.683333333333362 * sp[26] + -3.066666666666686 * sp[27] + -0.4333333333333275 * sp[31] + -0.4333333333333457 * sp[32] + 1.43333333333334 * sp[27] + -1.633333333333328 * sp[30];
    A[107] = 0.6000000000000036 * sp[33] + 0.1333333333333404 * sp[34] + -0.9333333333333452 * sp[28] + 0.5333333333333377 * sp[31] + 0.383333333333335 * sp[34] + -0.441666666666667 * sp[35] + -0.1416666666666686 * sp[29] + 0.09999999999999121 * sp[32] + 0.3833333333333365 * sp[28] + 0.9583333333333446 * sp[29] + -1.675000000000012 * sp[26] + 0.5333333333333454 * sp[27] + 0.3833333333333367 * sp[31] + 0.3833333333333408 * sp[32] + -0.8833333333333371 * sp[27] + 0.06666666666666354 * sp[30];
    A[108] = -2.600000000000006 * sp[33] + -1.133333333333348 * sp[34] + -7.533333333333329 * sp[28] + -3.933333333333334 * sp[31] + -1.383333333333333 * sp[34] + -0.2250000000000028 * sp[35] + -5.258333333333323 * sp[29] + -2.866666666666662 * sp[32] + -1.383333333333336 * sp[28] + -2.291666666666683 * sp[29] + 0.9416666666666652 * sp[26] + 0.03333333333332683 * sp[27] + -1.383333333333333 * sp[31] + -1.38333333333334 * sp[32] + -1.383333333333331 * sp[27] + -1.016666666666669 * sp[30];
    A[109] = 1.200000000000002 * sp[33] + 0.2666666666666757 * sp[34] + 3.733333333333324 * sp[28] + 5.86666666666665 * sp[31] + 0.7666666666666666 * sp[34] + -0.383333333333334 * sp[35] + 3.016666666666659 * sp[29] + 3.733333333333321 * sp[32] + 0.766666666666671 * sp[28] + 1.416666666666678 * sp[29] + -0.3833333333333273 * sp[26] + 0.2666666666666657 * sp[27] + 0.766666666666671 * sp[31] + 0.7666666666666735 * sp[32] + 0.7666666666666702 * sp[27] + 1.2 * sp[30];
    A[110] = -0.6000000000000015 * sp[33] + -0.4666666666666699 * sp[34] + -1.533333333333327 * sp[28] + -1.933333333333328 * sp[31] + -0.2166666666666666 * sp[34] + 0.3583333333333342 * sp[35] + -1.00833333333333 * sp[29] + -0.8666666666666669 * sp[32] + -0.2166666666666655 * sp[28] + -1.041666666666682 * sp[29] + 0.5250000000000102 * sp[26] + -0.3000000000000154 * sp[27] + -0.2166666666666635 * sp[31] + -0.2166666666666753 * sp[32] + -0.2166666666666582 * sp[27] + -0.1833333333333476 * sp[30];
    A[111] = -5.866666666666667 * sp[33] + -7.93333333333331 * sp[34] + -2.600000000000012 * sp[28] + -3.133333333333334 * sp[31] + -3.433333333333324 * sp[34] + -5.083333333333317 * sp[35] + -0.6833333333333321 * sp[29] + -1.399999999999997 * sp[32] + -2.76666666666668 * sp[28] + -1.683333333333314 * sp[29] + -4.216666666666681 * sp[26] + -3.133333333333335 * sp[27] + -2.299999999999999 * sp[31] + -2.23333333333332 * sp[32] + -2.300000000000001 * sp[27] + -2.016666666666664 * sp[30];
    A[112] = 11.73333333333335 * sp[33] + 5.866666666666651 * sp[34] + 5.866666666666694 * sp[28] + 4.266666666666661 * sp[31] + 5.866666666666651 * sp[34] + 3.833333333333321 * sp[35] + 1.366666666666661 * sp[29] + 1.79999999999999 * sp[32] + 5.866666666666694 * sp[28] + 1.366666666666661 * sp[29] + 8.766666666666703 * sp[26] + 4.266666666666667 * sp[27] + 4.266666666666661 * sp[31] + 1.79999999999999 * sp[32] + 4.266666666666667 * sp[27] + 2.533333333333323 * sp[30];
    A[113] = -5.866666666666678 * sp[33] + 2.066666666666683 * sp[34] + -3.266666666666689 * sp[28] + 1.533333333333347 * sp[31] + -2.433333333333325 * sp[34] + 0.4166666666666555 * sp[35] + -0.5166666666666635 * sp[29] + 0.5999999999999941 * sp[32] + -3.100000000000015 * sp[28] + 3.150000000000012 * sp[29] + -4.716666666666695 * sp[26] + 1.533333333333351 * sp[27] + -1.966666666666662 * sp[31] + 1.433333333333325 * sp[32] + -1.966666666666669 * sp[27] + 0.8166666666666679 * sp[30];
    A[114] = 5.656854249492397 * sp[33] + 1.885618083164107 * sp[34] + -9.42809041582065 * sp[28] + -20.74179891480542 * sp[31] + 3.299831645537224 * sp[34] + 2.592724864350706 * sp[35] + -3.064129385141693 * sp[29] + -8.485281374238504 * sp[32] + 3.299831645537243 * sp[28] + -3.064129385141727 * sp[29] + -14.3778378841265 * sp[26] + -20.74179891480546 * sp[27] + 3.299831645537237 * sp[31] + 0.4714045207910686 * sp[32] + -8.013876853447526 * sp[27] + -11.78511301977576 * sp[30];
    A[115] = 10.39230484541329 * sp[33] + -30.02221399786045 * sp[34] + -16.16580753730956 * sp[28] + -36.95041722813612 * sp[31] + -1.443375672974039 * sp[34] + -19.19689645055494 * sp[35] + -5.340489990004033 * sp[29] + -15.58845726811982 * sp[32] + -1.443375672974131 * sp[28] + -12.26869322027951 * sp[29] + -26.12509968083062 * sp[26] + -36.95041722813617 * sp[27] + -1.443375672974089 * sp[31] + -10.10362971081836 * sp[32] + -15.29978213352507 * sp[27] + -21.93931022920574 * sp[30];
    A[116] = -1.999999999999986 * sp[33] + -2.666666666666597 * sp[34] + 5.333333333333313 * sp[28] + 9.333333333333371 * sp[31] + -0.1666666666666518 * sp[34] + -8.416666666666687 * sp[35] + 1.583333333333308 * sp[29] + 2.999999999999936 * sp[32] + -0.1666666666666473 * sp[28] + 3.583333333333317 * sp[29] + 5.583333333333343 * sp[26] + 9.333333333333423 * sp[27] + -0.166666666666631 * sp[31] + -1.166666666666708 * sp[32] + 1.833333333333314 * sp[27] + 3.666666666666635 * sp[30];
    A[117] = 1.885618083164123 * sp[34] + 24.51303508113367 * sp[28] + 13.19932658214894 * sp[31] + -0.9428090415820666 * sp[34] + 0.4714045207910393 * sp[35] + 11.78511301977577 * sp[29] + 5.656854249492387 * sp[32] + -0.9428090415820958 * sp[28] + 0.4714045207910589 * sp[29] + 11.78511301977579 * sp[26] + 13.19932658214899 * sp[27] + -0.9428090415821009 * sp[31] + -0.9428090415820523 * sp[32] + 10.37089945740265 * sp[27] + 8.013876853447574 * sp[30];
    A[118] = -20.7846096908266 * sp[33] + -10.39230484541338 * sp[34] + -10.39230484541324 * sp[28] + 17.3205080756887 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137786 * sp[35] + -17.32050807568875 * sp[29] + 3.464101615137676 * sp[32] + -10.39230484541328 * sp[28] + -17.32050807568892 * sp[29] + 24.24871130596432 * sp[26] + 17.32050807568866 * sp[27] + -10.39230484541325 * sp[31] + -10.39230484541332 * sp[32] + 3.464101615137766 * sp[27] + 7.794228634059841 * sp[30];
    A[119] = 3.333333333333329 * sp[34] + -12.66666666666669 * sp[28] + -4.666666666666671 * sp[31] + -1.666666666666673 * sp[34] + 0.8333333333333437 * sp[35] + -7.166666666666639 * sp[29] + -7.99999999999992 * sp[32] + -1.666666666666707 * sp[28] + 0.8333333333333925 * sp[29] + -7.166666666666769 * sp[26] + -4.666666666666679 * sp[27] + -1.666666666666725 * sp[31] + -1.666666666666642 * sp[32] + -3.666666666666709 * sp[27] + -5.833333333333265 * sp[30];
    A[120] = -1.508333333333341 * sp[33] + -0.7333333333333406 * sp[34] + 2.800000000000013 * sp[28] + 0.9833333333333312 * sp[31] + 0.3083333333333438 * sp[34] + 0.7625000000000099 * sp[35] + -2.887500000000012 * sp[29] + -0.7166666666666639 * sp[32] + 0.3083333333333331 * sp[28] + -1.187500000000013 * sp[29] + 4.29583333333336 * sp[26] + 0.9833333333333367 * sp[27] + 0.3083333333333442 * sp[31] + 0.3083333333333413 * sp[32] + -1.391666666666682 * sp[27] + -0.4083333333333348 * sp[30];
    A[121] = 1.016666666666668 * sp[33] + 1.050000000000001 * sp[34] + -1.85000000000001 * sp[28] + 2.116666666666676 * sp[31] + -0.3666666666666806 * sp[34] + -1.275000000000012 * sp[35] + 2.025000000000009 * sp[29] + -2.48333333333334 * sp[32] + -0.366666666666668 * sp[28] + 1.958333333333342 * sp[29] + -3.008333333333352 * sp[26] + 2.116666666666678 * sp[27] + -0.3666666666666788 * sp[31] + -0.366666666666672 * sp[32] + 0.8666666666666747 * sp[27] + -1.266666666666674 * sp[30];
    A[122] = -0.09166666666666939 * sp[33] + -0.4000000000000067 * sp[34] + 0.4666666666666737 * sp[28] + -1.183333333333336 * sp[31] + -0.1083333333333387 * sp[34] + 0.6374999999999981 * sp[35] + -0.5125 * sp[29] + 2.116666666666679 * sp[32] + -0.1083333333333343 * sp[28] + -1.14583333333334 * sp[29] + 0.8375000000000088 * sp[26] + -1.18333333333334 * sp[27] + -0.1083333333333368 * sp[31] + -0.1083333333333368 * sp[32] + -0.1416666666666683 * sp[27] + 1.00833333333334 * sp[30];
    A[123] = 1.091666666666673 * sp[33] + 0.3583333333333445 * sp[34] + 3.225000000000004 * sp[28] + 1.341666666666674 * sp[31] + -0.01666666666666466 * sp[34] + -0.3875000000000005 * sp[35] + 0.9624999999999995 * sp[29] + 0.558333333333338 * sp[32] + -0.01666666666666461 * sp[28] + 0.7291666666666783 * sp[29] + -1.054166666666665 * sp[26] + -0.3083333333333285 * sp[27] + -0.01666666666666781 * sp[31] + -0.01666666666666933 * sp[32] + -0.0166666666666624 * sp[27] + 0.09166666666667252 * sp[30];
    A[124] = -0.1833333333333373 * sp[33] + -0.3000000000000098 * sp[34] + -0.866666666666667 * sp[28] + -1.933333333333332 * sp[31] + -0.2166666666666773 * sp[34] + 0.524999999999993 * sp[35] + -1.008333333333343 * sp[29] + -1.533333333333348 * sp[32] + -0.216666666666669 * sp[28] + -1.041666666666675 * sp[29] + 0.3583333333333298 * sp[26] + -0.4666666666666712 * sp[27] + -0.2166666666666737 * sp[31] + -0.2166666666666719 * sp[32] + -0.2166666666666772 * sp[27] + -0.6000000000000157 * sp[30];
    A[125] = 0.5083333333333335 * sp[33] + 0.7750000000000006 * sp[34] + 0.9749999999999964 * sp[28] + 0.5916666666666639 * sp[31] + -0.1833333333333403 * sp[34] + -1.012500000000006 * sp[35] + 0.1708333333333231 * sp[29] + 0.9749999999999911 * sp[32] + -0.1833333333333332 * sp[28] + 1.604166666666673 * sp[29] + -1.012500000000006 * sp[26] + 0.775000000000006 * sp[27] + -0.1833333333333392 * sp[31] + -0.1833333333333342 * sp[32] + -0.1833333333333414 * sp[27] + 0.5083333333333345 * sp[30];
    A[126] = 2.183333333333338 * sp[33] + 2.424999999999994 * sp[34] + 1.091666666666675 * sp[28] + 0.8583333333333352 * sp[31] + -0.2416666666666678 * sp[34] + 1.62500000000002 * sp[35] + -1.075 * sp[29] + 0.1583333333333435 * sp[32] + 1.091666666666679 * sp[28] + 0.2583333333333263 * sp[29] + 1.691666666666678 * sp[26] + 0.8583333333333358 * sp[27] + -0.4750000000000011 * sp[31] + 0.1583333333333461 * sp[32] + -0.475000000000006 * sp[27] + -0.03333333333333199 * sp[30];
    A[127] = -5.866666666666678 * sp[33] + -2.433333333333325 * sp[34] + -3.100000000000015 * sp[28] + -1.966666666666662 * sp[31] + 2.066666666666683 * sp[34] + 0.4166666666666555 * sp[35] + 3.150000000000012 * sp[29] + 1.433333333333325 * sp[32] + -3.266666666666689 * sp[28] + -0.5166666666666635 * sp[29] + -4.716666666666695 * sp[26] + -1.966666666666669 * sp[27] + 1.533333333333347 * sp[31] + 0.5999999999999941 * sp[32] + 1.533333333333351 * sp[27] + 0.8166666666666679 * sp[30];
    A[128] = 3.68333333333334 * sp[33] + -1.825000000000015 * sp[34] + 2.17500000000001 * sp[28] + -1.058333333333345 * sp[31] + -1.825000000000015 * sp[34] + 2.708333333333337 * sp[35] + -2.32500000000001 * sp[29] + 1.241666666666674 * sp[32] + 2.17500000000001 * sp[28] + -2.32500000000001 * sp[29] + 3.441666666666687 * sp[26] + -1.058333333333344 * sp[27] + -1.058333333333345 * sp[31] + 1.241666666666674 * sp[32] + -1.058333333333344 * sp[27] + 0.6333333333333393 * sp[30];
    A[129] = -1.649915822768628 * sp[33] + 4.949747468305826 * sp[34] + 3.535533905932753 * sp[28] + 11.5494107593803 * sp[31] + -0.4714045207910558 * sp[34] + -13.08147545195117 * sp[35] + -3.181980515339472 * sp[29] + -11.07800623858924 * sp[32] + -0.4714045207910396 * sp[28] + 6.246109900481175 * sp[29] + 4.8318963381081 * sp[26] + 11.54941075938032 * sp[27] + -0.4714045207910449 * sp[31] + -6.12825877028345 * sp[32] + -1.885618083164154 * sp[27] + -5.892556509887921 * sp[30];
    A[130] = -13.13471862406399 * sp[33] + 12.12435565298214 * sp[34] + 5.196152422706671 * sp[28] + 17.03183294109402 * sp[31] + -0.721687836486878 * sp[34] + -6.278684177437066 * sp[35] + -4.546633369868294 * sp[29] + -12.41303078757693 * sp[32] + -0.721687836486977 * sp[28] + 9.021097956087898 * sp[29] + 7.289047148519065 * sp[26] + 17.03183294109405 * sp[27] + -0.7216878364869339 * sp[31] + -5.051814855409164 * sp[32] + -2.453738644055947 * sp[27] + -7.072540797572953 * sp[30];
    A[131] = 3.083333333333324 * sp[33] + -9.500000000000046 * sp[34] + -3.499999999999979 * sp[28] + -11.33333333333334 * sp[31] + -1.583333333333401 * sp[34] + 13.37500000000008 * sp[35] + 3.375000000000029 * sp[29] + 17.66666666666673 * sp[32] + -1.583333333333339 * sp[28] + -8.458333333333325 * sp[29] + -4.458333333333336 * sp[26] + -11.33333333333338 * sp[27] + -1.583333333333387 * sp[31] + 3.916666666666724 * sp[32] + 2.416666666666691 * sp[27] + 8.583333333333382 * sp[30];
    A[132] = -2.357022603955144 * sp[33] + -2.121320343559617 * sp[34] + -13.43502884254442 * sp[28] + -5.421151989096881 * sp[31] + 1.649915822768678 * sp[34] + 2.121320343559695 * sp[35] + 3.535533905932796 * sp[29] + 3.064129385141732 * sp[32] + 1.649915822768623 * sp[28] + -2.592724864350676 * sp[29] + -1.178511301977583 * sp[26] + -5.421151989096915 * sp[27] + 1.649915822768663 * sp[31] + 1.64991582276864 * sp[32] + 3.064129385141769 * sp[27] + 1.885618083164156 * sp[30];
    A[133] = 10.39230484541332 * sp[33] + 3.031088913245604 * sp[34] + 3.031088913245543 * sp[28] + -10.82531754730545 * sp[31] + -1.299038105676696 * sp[34] + -2.598076211353357 * sp[35] + 4.330127018922271 * sp[29] + 4.763139720814385 * sp[32] + -1.299038105676656 * sp[28] + 4.330127018922282 * sp[29] + -16.45448267190437 * sp[26] + -10.82531754730544 * sp[27] + -1.299038105676712 * sp[31] + -1.299038105676709 * sp[32] + 0.4330127018922959 * sp[27] + 2.598076211353327 * sp[30];
    A[134] = -4.166666666666643 * sp[33] + -3.749999999999957 * sp[34] + 4.250000000000017 * sp[28] + 1.916666666666697 * sp[31] + 2.91666666666679 * sp[34] + 3.750000000000098 * sp[35] + -2.24999999999996 * sp[29] + -13.0833333333332 * sp[32] + 2.916666666666681 * sp[28] + -4.583333333333345 * sp[29] + 9.416666666666732 * sp[26] + 1.916666666666698 * sp[27] + 2.916666666666761 * sp[31] + 2.916666666666718 * sp[32] + -1.08333333333329 * sp[27] + -6.666666666666607 * sp[30];
    A[135] = 1.649915822768633 * sp[33] + 3.064129385141738 * sp[34] + -1.649915822768627 * sp[28] + -1.649915822768631 * sp[31] + 0.4714045207910287 * sp[34] + 1.767766952966348 * sp[35] + 5.0675985985036 * sp[29] + -0.2357022603955423 * sp[32] + -5.185449728701353 * sp[28] + -3.889087296526057 * sp[29] + 10.72445284799601 * sp[26] + 4.006938426723767 * sp[27] + -5.185449728701375 * sp[31] + -5.185449728701424 * sp[32] + 17.44196726926824 * sp[27] + 5.892556509887891 * sp[30];
    A[136] = 3.77123616632826 * sp[33] + -3.771236166328296 * sp[34] + 0.9428090415820782 * sp[28] + 0.9428090415820819 * sp[31] + 6.128258770283434 * sp[34] + 1.178511301977601 * sp[35] + -5.421151989096851 * sp[29] + 12.25651754056687 * sp[32] + 3.299831645537219 * sp[28] + -1.649915822768568 * sp[29] + -2.592724864350705 * sp[26] + 3.77123616632828 * sp[27] + 3.299831645537242 * sp[31] + 3.299831645537291 * sp[32] + -8.956685895029651 * sp[27] + 11.7851130197758 * sp[30];
    A[137] = 4.006938426723798 * sp[33] + 10.13519719700725 * sp[34] + -4.006938426723797 * sp[28] + -4.006938426723785 * sp[31] + 5.185449728701378 * sp[34] + 7.660323462854293 * sp[35] + -3.181980515339481 * sp[29] + -16.73486048808168 * sp[32] + -0.4714045207910356 * sp[28] + 2.003469213361877 * sp[29] + 2.474873734152925 * sp[26] + 1.649915822768593 * sp[27] + -0.4714045207910317 * sp[31] + -0.4714045207910549 * sp[32] + 3.299831645537243 * sp[27] + -5.892556509887909 * sp[30];
    A[138] = -7.542472332656546 * sp[33] + -7.778174593052063 * sp[34] + -8.720983634634116 * sp[28] + -7.778174593052043 * sp[31] + -8.720983634634109 * sp[34] + -8.249579113843055 * sp[35] + -12.9636243217534 * sp[29] + -11.07800623858925 * sp[32] + 4.006938426723768 * sp[28] + 4.478342947514816 * sp[29] + -0.2357022603955219 * sp[26] + 0.235702260395517 * sp[27] + 4.006938426723774 * sp[31] + 4.00693842672381 * sp[32] + 4.006938426723742 * sp[27] + 2.357022603955149 * sp[30];
    A[139] = 8.013876853447581 * sp[33] + 13.19932658214896 * sp[34] + 5.656854249492385 * sp[28] + 13.19932658214891 * sp[31] + 10.37089945740274 * sp[34] + 11.78511301977584 * sp[35] + 11.7851130197758 * sp[29] + 24.5130350811337 * sp[32] + -0.9428090415820651 * sp[28] + 0.4714045207910298 * sp[29] + 0.4714045207910273 * sp[26] + 1.885618083164153 * sp[27] + -0.9428090415820558 * sp[31] + -0.9428090415820792 * sp[32] + -0.9428090415820375 * sp[27];
    A[140] = 1.885618083164127 * sp[33] + -5.421151989096912 * sp[34] + 3.064129385141719 * sp[28] + -5.421151989096904 * sp[31] + 3.064129385141714 * sp[34] + -1.17851130197758 * sp[35] + 3.535533905932762 * sp[29] + -13.4350288425444 * sp[32] + 1.649915822768608 * sp[28] + -2.592724864350651 * sp[29] + 2.121320343559633 * sp[26] + -2.121320343559617 * sp[27] + 1.649915822768619 * sp[31] + 1.649915822768651 * sp[32] + 1.649915822768606 * sp[27] + -2.357022603955104 * sp[30];
    A[141] = -4.006938426723764 * sp[33] + -5.185449728701318 * sp[34] + -5.185449728701379 * sp[28] + -5.185449728701361 * sp[31] + -6.835365551469932 * sp[34] + -18.97403196183908 * sp[35] + -4.360491817317047 * sp[29] + -10.84230397819378 * sp[32] + 5.892556509887902 * sp[28] + 5.067598598503549 * sp[29] + 8.36743024404082 * sp[26] + 7.542472332656502 * sp[27] + 9.192388155425117 * sp[31] + 5.421151989096761 * sp[32] + 9.192388155425142 * sp[27] + 5.892556509887878 * sp[30];
    A[142] = 5.656854249492397 * sp[33] + 3.299831645537224 * sp[34] + 3.299831645537243 * sp[28] + 3.299831645537237 * sp[31] + 1.885618083164107 * sp[34] + 2.592724864350706 * sp[35] + -3.064129385141727 * sp[29] + 0.4714045207910686 * sp[32] + -9.42809041582065 * sp[28] + -3.064129385141693 * sp[29] + -14.3778378841265 * sp[26] + -8.013876853447526 * sp[27] + -20.74179891480542 * sp[31] + -8.485281374238504 * sp[32] + -20.74179891480546 * sp[27] + -11.78511301977576 * sp[30];
    A[143] = -1.649915822768628 * sp[33] + -0.4714045207910558 * sp[34] + -0.4714045207910396 * sp[28] + -0.4714045207910449 * sp[31] + 4.949747468305826 * sp[34] + -13.08147545195117 * sp[35] + 6.246109900481175 * sp[29] + -6.12825877028345 * sp[32] + 3.535533905932753 * sp[28] + -3.181980515339472 * sp[29] + 4.8318963381081 * sp[26] + -1.885618083164154 * sp[27] + 11.5494107593803 * sp[31] + -11.07800623858924 * sp[32] + 11.54941075938032 * sp[27] + -5.892556509887921 * sp[30];
    A[144] = 26.66666666666682 * sp[33] + 33.33333333333346 * sp[34] + -6.666666666666696 * sp[28] + -6.66666666666668 * sp[31] + 33.33333333333346 * sp[34] + 113.3333333333336 * sp[35] + -6.6666666666666 * sp[29] + 33.33333333333331 * sp[32] + -6.666666666666696 * sp[28] + -6.6666666666666 * sp[29] + 33.33333333333336 * sp[26] + 33.33333333333339 * sp[27] + -6.66666666666668 * sp[31] + 33.33333333333331 * sp[32] + 33.33333333333339 * sp[27] + 66.66666666666659 * sp[30];
    A[145] = 4.082482904638791 * sp[33] + -4.082482904638409 * sp[34] + -28.57738033247058 * sp[28] + -28.57738033247046 * sp[31] + 8.16496580927739 * sp[34] + 14.28869016623506 * sp[35] + -34.70110468942833 * sp[29] + -4.082482904638717 * sp[32] + 8.164965809277302 * sp[28] + 14.28869016623508 * sp[29] + 63.2784850218988 * sp[26] + 69.40220937885682 * sp[27] + 8.164965809276982 * sp[31] + 57.15476066494023 * sp[32] + 57.15476066494093 * sp[27] + 102.0620726159657 * sp[30];
    A[146] = 25.92724864350692 * sp[33] + 16.49915822768625 * sp[34] + -25.92724864350689 * sp[28] + -25.92724864350679 * sp[31] + 37.71236166328279 * sp[34] + -64.81812160876687 * sp[35] + -36.53385036130507 * sp[29] + -124.9221980096237 * sp[32] + 9.428090415820618 * sp[28] + 20.03469213361888 * sp[29] + -8.249579113843099 * sp[26] + 2.357022603955023 * sp[27] + 9.428090415820694 * sp[31] + -18.85618083164136 * sp[32] + -18.85618083164126 * sp[27] + -58.92556509887899 * sp[30];
    A[147] = -33.33333333333351 * sp[33] + -26.66666666666677 * sp[34] + 13.33333333333347 * sp[28] + 13.33333333333348 * sp[31] + -46.66666666666688 * sp[34] + -36.66666666666687 * sp[35] + 3.333333333333336 * sp[29] + 13.33333333333333 * sp[32] + -6.66666666666663 * sp[28] + 3.333333333333234 * sp[29] + -36.66666666666664 * sp[26] + -26.66666666666684 * sp[27] + -6.66666666666671 * sp[31] + -6.666666666666803 * sp[32] + -46.66666666666674 * sp[27] + -33.33333333333357 * sp[30];
    A[148] = -36.7423461417478 * sp[33] + -24.49489742783193 * sp[34] + -24.4948974278319 * sp[28] + -36.7423461417476 * sp[34] + -30.61862178478958 * sp[35] + -6.123724356958125 * sp[29] + 36.74234614174773 * sp[28] + 42.86607049870585 * sp[29] + -30.61862178478978 * sp[26] + -24.49489742783155 * sp[27] + 36.74234614174784 * sp[31] + 36.74234614174809 * sp[32] + -12.24744871391626 * sp[27] + -36.7423461417473 * sp[30];
    A[149] = -58.92556509887925 * sp[33] + -47.14045207910328 * sp[34] + -18.85618083164128 * sp[28] + -4.714045207910239 * sp[31] + -82.4957911384309 * sp[34] + -64.81812160876716 * sp[35] + -22.39171473757409 * sp[29] + 80.13876853447539 * sp[32] + -11.78511301977576 * sp[28] + 5.892556509887728 * sp[29] + -8.24957911384295 * sp[26] + 9.428090415820565 * sp[27] + -11.7851130197759 * sp[31] + -11.78511301977604 * sp[32] + 16.4991582276861 * sp[27] + 54.21151989096814 * sp[30];
    A[150] = 10.96965511460291 * sp[33] + 0.1443375672973231 * sp[34] + 0.7216878364871026 * sp[28] + 0.7216878364870889 * sp[31] + 0.7216878364869765 * sp[34] + -1.732050807568897 * sp[35] + 11.54700538379249 * sp[29] + 5.051814855409215 * sp[32] + -10.53664241271068 * sp[28] + -8.660254037844483 * sp[29] + 18.47520861406809 * sp[26] + 7.649891066762549 * sp[27] + -10.53664241271073 * sp[31] + -10.53664241271079 * sp[32] + 29.30052616137364 * sp[27] + 10.9696551146029 * sp[30];
    A[151] = -8.94892917243917 * sp[33] + -3.175426480542803 * sp[34] + 1.443375672974014 * sp[28] + 1.44337567297395 * sp[31] + -1.44337567297397 * sp[34] + 2.020725942163686 * sp[35] + -7.216878364870327 * sp[29] + 10.10362971081832 * sp[32] + 3.75277674973255 * sp[28] + -1.443375672973957 * sp[29] + -3.752776749732625 * sp[26] + 4.907477288111856 * sp[27] + 3.752776749732607 * sp[31] + 3.752776749732665 * sp[32] + -12.41303078757705 * sp[27] + 14.14508159514584 * sp[30];
    A[152] = -0.5773502691895994 * sp[33] + 4.474464586219613 * sp[34] + -0.7216878364870354 * sp[28] + -0.7216878364870181 * sp[31] + -0.7216878364869961 * sp[34] + 4.041451884327452 * sp[35] + -5.051814855409171 * sp[32] + -3.319764047840375 * sp[28] + -2.886751345948183 * sp[29] + 6.928203230275534 * sp[26] + 6.206515393788455 * sp[27] + -3.319764047840355 * sp[31] + -3.319764047840363 * sp[32] + 7.649891066762579 * sp[27] + -0.5773502691896271 * sp[30];
    A[153] = -5.917840259193718 * sp[33] + -0.8660254037844548 * sp[34] + -11.83568051838745 * sp[28] + -0.8660254037845543 * sp[31] + 0.721687836486999 * sp[34] + -2.237232293109827 * sp[35] + 18.25870226312184 * sp[29] + 10.96965511460279 * sp[32] + 11.98001808568475 * sp[28] + 13.35122497501014 * sp[29] + 2.670244995002045 * sp[26] + 4.041451884327407 * sp[27] + 11.98001808568475 * sp[31] + 11.98001808568479 * sp[32] + 11.98001808568472 * sp[27] + 8.804591605141777 * sp[30];
    A[154] = -1.154700538379199 * sp[33] + 4.618802153517063 * sp[34] + -5.196152422706544 * sp[28] + 4.618802153517104 * sp[31] + -1.443375672973983 * sp[34] + 5.917840259193757 * sp[35] + -14.86676943163274 * sp[29] + -16.16580753730938 * sp[32] + -6.639528095680731 * sp[28] + -7.938566201357402 * sp[29] + -1.010362971081876 * sp[26] + -2.309401076758491 * sp[27] + -6.639528095680689 * sp[31] + -6.639528095680699 * sp[32] + -6.639528095680665 * sp[27] + -10.39230484541319 * sp[30];
    A[155] = -4.474464586219581 * sp[33] + -3.752776749732486 * sp[34] + -8.948929172439192 * sp[28] + -3.75277674973246 * sp[31] + -0.7216878364869855 * sp[34] + -0.07216878364874107 * sp[35] + 0.2165063509461669 * sp[29] + 5.19615242270663 * sp[32] + 1.876388374866273 * sp[28] + -1.804219591217503 * sp[29] + 1.94855715851496 * sp[26] + -1.732050807568791 * sp[27] + 1.876388374866302 * sp[31] + 1.876388374866333 * sp[32] + 1.876388374866283 * sp[27] + 1.587713240271555 * sp[30];
    A[156] = 2.742413778650683 * sp[33] + 0.7216878364868693 * sp[34] + 0.7216878364870403 * sp[28] + 0.7216878364869994 * sp[31] + 17.89785834487832 * sp[34] + 24.75389279150506 * sp[35] + 2.525907427704577 * sp[29] + 5.05181485540918 * sp[32] + 10.9696551146029 * sp[28] + 9.165435523385241 * sp[29] + 18.11436469582453 * sp[26] + 16.31014510460692 * sp[27] + 19.9185842870421 * sp[31] + 19.34123401785235 * sp[32] + 19.91858428704214 * sp[27] + 17.46484564298618 * sp[30];
    A[157] = 10.39230484541329 * sp[33] + -1.443375672974039 * sp[34] + -1.443375672974131 * sp[28] + -1.443375672974089 * sp[31] + -30.02221399786045 * sp[34] + -19.19689645055494 * sp[35] + -12.26869322027951 * sp[29] + -10.10362971081836 * sp[32] + -16.16580753730956 * sp[28] + -5.340489990004033 * sp[29] + -26.12509968083062 * sp[26] + -15.29978213352507 * sp[27] + -36.95041722813612 * sp[31] + -15.58845726811982 * sp[32] + -36.95041722813617 * sp[27] + -21.93931022920574 * sp[30];
    A[158] = -13.13471862406399 * sp[33] + -0.721687836486878 * sp[34] + -0.721687836486977 * sp[28] + -0.7216878364869339 * sp[31] + 12.12435565298214 * sp[34] + -6.278684177437066 * sp[35] + 9.021097956087898 * sp[29] + -5.051814855409164 * sp[32] + 5.196152422706671 * sp[28] + -4.546633369868294 * sp[29] + 7.289047148519065 * sp[26] + -2.453738644055947 * sp[27] + 17.03183294109402 * sp[31] + -12.41303078757693 * sp[32] + 17.03183294109405 * sp[27] + -7.072540797572953 * sp[30];
    A[159] = 4.082482904638791 * sp[33] + 8.16496580927739 * sp[34] + 8.164965809277302 * sp[28] + 8.164965809276982 * sp[31] + -4.082482904638409 * sp[34] + 14.28869016623506 * sp[35] + 14.28869016623508 * sp[29] + 57.15476066494023 * sp[32] + -28.57738033247058 * sp[28] + -34.70110468942833 * sp[29] + 63.2784850218988 * sp[26] + 57.15476066494093 * sp[27] + -28.57738033247046 * sp[31] + -4.082482904638717 * sp[32] + 69.40220937885682 * sp[27] + 102.0620726159657 * sp[30];
    A[160] = 189.9999999999995 * sp[33] + 57.49999999999886 * sp[34] + 12.50000000000001 * sp[28] + 12.49999999999949 * sp[31] + 57.49999999999886 * sp[34] + 132.4999999999987 * sp[35] + 12.49999999999975 * sp[29] + 87.4999999999992 * sp[32] + 12.50000000000001 * sp[28] + 12.49999999999975 * sp[29] + 132.5000000000001 * sp[26] + 132.5000000000002 * sp[27] + 12.49999999999949 * sp[31] + 87.4999999999992 * sp[32] + 132.5000000000002 * sp[27] + 190.0000000000002 * sp[30];
    A[161] = -31.75426480542923 * sp[33] + 105.3664241271069 * sp[34] + -7.216878364870521 * sp[28] + -7.21687836487035 * sp[31] + -7.216878364869941 * sp[34] + 57.73502691896251 * sp[35] + -28.8675134594813 * sp[29] + -50.51814855409182 * sp[32] + 1.443375672973896 * sp[28] + 23.09401076758506 * sp[29] + 5.773502691896256 * sp[26] + 27.42413778650701 * sp[27] + 1.443375672974133 * sp[31] + 10.10362971081849 * sp[32] + -15.87713240271476 * sp[27] + -31.75426480542944 * sp[30];
    A[162] = 28.57738033247015 * sp[33] + -4.082482904639184 * sp[34] + 69.40220937885672 * sp[28] + -4.082482904638992 * sp[31] + 8.164965809276778 * sp[34] + -22.45365597551272 * sp[35] + -22.45365597551264 * sp[29] + -28.57738033247039 * sp[32] + 8.164965809277474 * sp[28] + 26.53613888015096 * sp[29] + -71.44345083117605 * sp[26] + -53.0722777603026 * sp[27] + 8.164965809277202 * sp[31] + 8.164965809277026 * sp[32] + -89.81462390205006 * sp[27] + -69.40220937885718 * sp[30];
    A[163] = -67.50000000000031 * sp[33] + 7.500000000000174 * sp[34] + 7.499999999998977 * sp[28] + 52.50000000000026 * sp[31] + 3.750000000000099 * sp[35] + 48.74999999999937 * sp[29] + -22.49999999999978 * sp[32] + 90.00000000000014 * sp[28] + 93.75000000000043 * sp[29] + -41.24999999999994 * sp[26] + -37.49999999999953 * sp[27] + 90.0000000000003 * sp[31] + 90.00000000000068 * sp[32] + -30.00000000000053 * sp[27] + -67.49999999999953 * sp[30];
    A[164] = 50.51814855409177 * sp[33] + -7.216878364871278 * sp[34] + 44.74464586219586 * sp[28] + 105.3664241271056 * sp[31] + 14.43375672973979 * sp[34] + -39.6928310067872 * sp[35] + 72.89047148518966 * sp[29] + 62.06515393788342 * sp[32] + 14.43375672974096 * sp[28] + 46.90970937165683 * sp[29] + -13.71206889325335 * sp[26] + 18.76388374866266 * sp[27] + 14.43375672974047 * sp[31] + 14.43375672974019 * sp[32] + 31.75426480542946 * sp[27] + 50.51814855409141 * sp[30];
    A[165] = -6.83333333333332 * sp[33] + 2.416666666666691 * sp[34] + 0.08333333333332457 * sp[28] + 0.08333333333329346 * sp[31] + 1.583333333333359 * sp[34] + 3.749999999999999 * sp[35] + -4.916666666666637 * sp[29] + 0.5833333333333677 * sp[32] + 0.08333333333333703 * sp[28] + -1.250000000000007 * sp[29] + -5.916666666666677 * sp[26] + -0.9166666666666496 * sp[27] + 0.08333333333335347 * sp[31] + 0.08333333333339676 * sp[32] + -10.91666666666673 * sp[27] + -1.83333333333332 * sp[30];
    A[166] = 11.16666666666668 * sp[33] + -8.16666666666671 * sp[34] + 3.166666666666682 * sp[28] + 3.16666666666673 * sp[31] + 1.833333333333341 * sp[34] + -16.66666666666671 * sp[35] + 10.66666666666666 * sp[29] + -7.833333333333409 * sp[32] + -5.166666666666692 * sp[28] + 3.333333333333385 * sp[29] + 2.66666666666666 * sp[26] + -4.833333333333356 * sp[27] + -5.166666666666687 * sp[31] + -5.166666666666739 * sp[32] + 10.1666666666667 * sp[27] + -17.16666666666673 * sp[30];
    A[167] = 4.833333333333365 * sp[33] + 14.91666666666675 * sp[34] + -4.083333333333373 * sp[28] + -4.083333333333373 * sp[31] + 2.41666666666669 * sp[34] + 22.91666666666678 * sp[35] + -5.75000000000002 * sp[29] + 11.41666666666674 * sp[32] + -4.083333333333362 * sp[28] + -12.08333333333341 * sp[29] + 3.250000000000015 * sp[26] + 4.916666666666677 * sp[27] + -4.083333333333348 * sp[31] + -4.083333333333296 * sp[32] + 1.583333333333316 * sp[27] + 19.83333333333341 * sp[30];
    A[168] = -3.583333333333381 * sp[33] + -7.000000000000052 * sp[34] + -2.66666666666671 * sp[28] + -7.000000000000019 * sp[31] + -4.916666666666716 * sp[34] + -7.708333333333378 * sp[35] + 4.458333333333227 * sp[29] + 2.166666666666583 * sp[32] + 6.583333333333361 * sp[28] + 7.291666666666682 * sp[29] + 5.45833333333338 * sp[26] + 6.166666666666693 * sp[27] + 6.583333333333329 * sp[31] + 6.583333333333281 * sp[32] + 6.583333333333385 * sp[27] + 6.916666666666667 * sp[30];
    A[169] = 9.666666666666725 * sp[33] + 17.33333333333344 * sp[34] + 7.000000000000005 * sp[28] + 17.3333333333334 * sp[31] + 4.833333333333377 * sp[34] + 24.58333333333346 * sp[35] + -11.41666666666663 * sp[29] + -2.666666666666603 * sp[32] + -8.166666666666714 * sp[28] + -15.41666666666674 * sp[29] + -3.416666666666689 * sp[26] + -10.66666666666673 * sp[27] + -8.166666666666687 * sp[31] + -8.166666666666636 * sp[32] + -8.166666666666705 * sp[27] + -18.00000000000007 * sp[30];
    A[170] = 5.58333333333333 * sp[33] + -10.33333333333339 * sp[34] + 10.66666666666668 * sp[28] + -10.33333333333339 * sp[31] + 0.9166666666666663 * sp[34] + -18.95833333333341 * sp[35] + 4.874999999999996 * sp[29] + 0.5 * sp[32] + -2.583333333333342 * sp[28] + 6.041666666666734 * sp[29] + -4.125000000000018 * sp[26] + 4.500000000000062 * sp[27] + -2.583333333333341 * sp[31] + -2.583333333333382 * sp[32] + -2.583333333333334 * sp[27] + 11.08333333333331 * sp[30];
    A[171] = -1.083333333333329 * sp[33] + -2.416666666666636 * sp[34] + -2.416666666666706 * sp[28] + -2.416666666666687 * sp[31] + 12.16666666666665 * sp[34] + 27.95833333333337 * sp[35] + -2.208333333333341 * sp[29] + 8.083333333333385 * sp[32] + -1.83333333333334 * sp[28] + -2.041666666666659 * sp[29] + 1.791666666666675 * sp[26] + 1.583333333333335 * sp[27] + 1.99999999999998 * sp[31] + 14.33333333333348 * sp[32] + 1.99999999999996 * sp[27] + 9.416666666666712 * sp[30];
    A[172] = -1.999999999999986 * sp[33] + -0.1666666666666518 * sp[34] + -0.1666666666666473 * sp[28] + -0.166666666666631 * sp[31] + -2.666666666666597 * sp[34] + -8.416666666666687 * sp[35] + 3.583333333333317 * sp[29] + -1.166666666666708 * sp[32] + 5.333333333333313 * sp[28] + 1.583333333333308 * sp[29] + 5.583333333333343 * sp[26] + 1.833333333333314 * sp[27] + 9.333333333333371 * sp[31] + 2.999999999999936 * sp[32] + 9.333333333333423 * sp[27] + 3.666666666666635 * sp[30];
    A[173] = 3.083333333333324 * sp[33] + -1.583333333333401 * sp[34] + -1.583333333333339 * sp[28] + -1.583333333333387 * sp[31] + -9.500000000000046 * sp[34] + 13.37500000000008 * sp[35] + -8.458333333333325 * sp[29] + 3.916666666666724 * sp[32] + -3.499999999999979 * sp[28] + 3.375000000000029 * sp[29] + -4.458333333333336 * sp[26] + 2.416666666666691 * sp[27] + -11.33333333333334 * sp[31] + 17.66666666666673 * sp[32] + -11.33333333333338 * sp[27] + 8.583333333333382 * sp[30];
    A[174] = 25.92724864350692 * sp[33] + 37.71236166328279 * sp[34] + 9.428090415820618 * sp[28] + 9.428090415820694 * sp[31] + 16.49915822768625 * sp[34] + -64.81812160876687 * sp[35] + 20.03469213361888 * sp[29] + -18.85618083164136 * sp[32] + -25.92724864350689 * sp[28] + -36.53385036130507 * sp[29] + -8.249579113843099 * sp[26] + -18.85618083164126 * sp[27] + -25.92724864350679 * sp[31] + -124.9221980096237 * sp[32] + 2.357022603955023 * sp[27] + -58.92556509887899 * sp[30];
    A[175] = -31.75426480542923 * sp[33] + -7.216878364869941 * sp[34] + 1.443375672973896 * sp[28] + 1.443375672974133 * sp[31] + 105.3664241271069 * sp[34] + 57.73502691896251 * sp[35] + 23.09401076758506 * sp[29] + 10.10362971081849 * sp[32] + -7.216878364870521 * sp[28] + -28.8675134594813 * sp[29] + 5.773502691896256 * sp[26] + -15.87713240271476 * sp[27] + -7.21687836487035 * sp[31] + -50.51814855409182 * sp[32] + 27.42413778650701 * sp[27] + -31.75426480542944 * sp[30];
    A[176] = 53.33333333333354 * sp[33] + 14.16666666666678 * sp[34] + -30.83333333333358 * sp[28] + -30.83333333333351 * sp[31] + 14.16666666666678 * sp[34] + 219.1666666666673 * sp[35] + -30.83333333333353 * sp[29] + 84.16666666666703 * sp[32] + -30.83333333333358 * sp[28] + -30.83333333333353 * sp[29] + 39.16666666666679 * sp[26] + 39.16666666666666 * sp[27] + -30.83333333333351 * sp[31] + 84.16666666666703 * sp[32] + 39.16666666666666 * sp[27] + 153.3333333333337 * sp[30];
    A[177] = -58.92556509887916 * sp[33] + -25.92724864350691 * sp[34] + -40.06938426723754 * sp[28] + 2.357022603955293 * sp[31] + -18.85618083164143 * sp[34] + -22.39171473757424 * sp[35] + 5.892556509888074 * sp[29] + -11.78511301977589 * sp[32] + 37.71236166328276 * sp[28] + 34.17682775734988 * sp[29] + 5.892556509887848 * sp[26] + 2.357022603955108 * sp[27] + 37.71236166328266 * sp[31] + 37.71236166328266 * sp[32] + 9.428090415820691 * sp[27] + -2.357022603955032 * sp[30];
    A[178] = 12.99038105676654 * sp[33] + -4.330127018922303 * sp[34] + -4.330127018922363 * sp[28] + -12.99038105676661 * sp[31] + -25.98076211353329 * sp[34] + 10.82531754730554 * sp[35] + 2.16506350946057 * sp[29] + 12.99038105676643 * sp[32] + 25.98076211353312 * sp[28] + 10.82531754730538 * sp[29] + 36.80607966083878 * sp[26] + 21.65063509461088 * sp[27] + 25.98076211353295 * sp[31] + 25.98076211353277 * sp[32] + -8.660254037844052 * sp[27] + 12.99038105676612 * sp[30];
    A[179] = -104.166666666667 * sp[33] + -45.83333333333357 * sp[34] + -55.83333333333333 * sp[28] + -0.8333333333332065 * sp[31] + -33.33333333333361 * sp[34] + -39.58333333333363 * sp[35] + 5.416666666666618 * sp[29] + -25.8333333333336 * sp[32] + 66.66666666666703 * sp[28] + 60.41666666666676 * sp[29] + 5.416666666666783 * sp[26] + -0.833333333333437 * sp[27] + 66.66666666666688 * sp[31] + 66.66666666666687 * sp[32] + -3.333333333333266 * sp[27] + -104.1666666666667 * sp[30];
    A[180] = 5.892556509887874 * sp[33] + -3.299831645537254 * sp[34] + 0.4714045207910518 * sp[28] + 0.4714045207910752 * sp[31] + -1.649915822768609 * sp[34] + -2.474873734152928 * sp[35] + -2.003469213361901 * sp[29] + 0.4714045207910343 * sp[32] + 16.73486048808164 * sp[28] + 3.1819805153395 * sp[29] + -7.660323462854275 * sp[26] + -5.185449728701318 * sp[27] + 4.006938426723789 * sp[31] + 4.006938426723837 * sp[32] + -10.13519719700727 * sp[27] + -4.006938426723797 * sp[30];
    A[181] = -11.78511301977579 * sp[33] + 8.956685895029649 * sp[34] + -3.299831645537243 * sp[28] + -3.299831645537283 * sp[31] + -3.771236166328269 * sp[34] + 2.592724864350735 * sp[35] + 1.649915822768599 * sp[29] + -3.299831645537264 * sp[32] + -12.25651754056681 * sp[28] + 5.421151989096827 * sp[29] + -1.178511301977565 * sp[26] + -6.128258770283466 * sp[27] + -0.9428090415820524 * sp[31] + -0.9428090415821058 * sp[32] + 3.771236166328302 * sp[27] + -3.77123616632829 * sp[30];
    A[182] = -5.892556509887928 * sp[33] + -17.44196726926826 * sp[34] + 5.18544972870139 * sp[28] + 5.185449728701384 * sp[31] + -4.00693842672379 * sp[34] + -10.72445284799604 * sp[35] + 3.88908729652602 * sp[29] + 5.18544972870137 * sp[32] + 0.2357022603955388 * sp[28] + -5.067598598503555 * sp[29] + -1.767766952966376 * sp[26] + -0.4714045207910136 * sp[27] + 1.649915822768634 * sp[31] + 1.649915822768649 * sp[32] + -3.064129385141744 * sp[27] + -1.649915822768604 * sp[30];
    A[183] = 5.892556509887946 * sp[33] + 9.192388155425171 * sp[34] + 5.421151989096892 * sp[28] + 9.192388155425123 * sp[31] + 7.542472332656521 * sp[34] + 8.367430244040817 * sp[35] + 5.067598598503625 * sp[29] + 5.892556509887903 * sp[32] + -10.84230397819375 * sp[28] + -4.360491817317069 * sp[29] + -18.97403196183906 * sp[26] + -6.835365551470012 * sp[27] + -5.185449728701384 * sp[31] + -5.185449728701411 * sp[32] + -5.185449728701346 * sp[27] + -4.006938426723791 * sp[30];
    A[184] = -11.78511301977584 * sp[33] + -20.74179891480549 * sp[34] + -8.485281374238559 * sp[28] + -20.74179891480543 * sp[31] + -8.01387685344757 * sp[34] + -14.37783788412653 * sp[35] + -3.064129385141712 * sp[29] + -9.428090415820687 * sp[32] + 0.4714045207910615 * sp[28] + -3.064129385141671 * sp[29] + 2.59272486435071 * sp[26] + 1.885618083164133 * sp[27] + 3.299831645537259 * sp[31] + 3.299831645537272 * sp[32] + 3.299831645537235 * sp[27] + 5.656854249492365 * sp[30];
    A[185] = -5.892556509887887 * sp[33] + 11.54941075938034 * sp[34] + -11.07800623858926 * sp[28] + 11.54941075938032 * sp[31] + -1.885618083164132 * sp[34] + 4.831896338108142 * sp[35] + -3.181980515339476 * sp[29] + 3.535533905932828 * sp[32] + -6.128258770283392 * sp[28] + 6.246109900481143 * sp[29] + -13.08147545195111 * sp[26] + 4.949747468305808 * sp[27] + -0.4714045207910257 * sp[31] + -0.4714045207910602 * sp[32] + -0.4714045207910036 * sp[27] + -1.649915822768621 * sp[30];
    A[186] = 2.357022603955142 * sp[33] + 4.006938426723712 * sp[34] + 4.006938426723815 * sp[28] + 4.006938426723788 * sp[31] + 0.2357022603954899 * sp[34] + -0.2357022603955223 * sp[35] + 4.478342947514792 * sp[29] + 4.006938426723761 * sp[32] + -11.07800623858925 * sp[28] + -12.96362432175338 * sp[29] + -8.249579113843055 * sp[26] + -8.720983634634083 * sp[27] + -7.778174593052057 * sp[31] + -8.720983634634052 * sp[32] + -7.778174593052087 * sp[27] + -7.542472332656542 * sp[30];
    A[187] = -0.9428090415820666 * sp[34] + -0.9428090415820958 * sp[28] + -0.9428090415821009 * sp[31] + 1.885618083164123 * sp[34] + 0.4714045207910393 * sp[35] + 0.4714045207910589 * sp[29] + -0.9428090415820523 * sp[32] + 24.51303508113367 * sp[28] + 11.78511301977577 * sp[29] + 11.78511301977579 * sp[26] + 10.37089945740265 * sp[27] + 13.19932658214894 * sp[31] + 5.656854249492387 * sp[32] + 13.19932658214899 * sp[27] + 8.013876853447574 * sp[30];
    A[188] = -2.357022603955144 * sp[33] + 1.649915822768678 * sp[34] + 1.649915822768623 * sp[28] + 1.649915822768663 * sp[31] + -2.121320343559617 * sp[34] + 2.121320343559695 * sp[35] + -2.592724864350676 * sp[29] + 1.64991582276864 * sp[32] + -13.43502884254442 * sp[28] + 3.535533905932796 * sp[29] + -1.178511301977583 * sp[26] + 3.064129385141769 * sp[27] + -5.421151989096881 * sp[31] + 3.064129385141732 * sp[32] + -5.421151989096915 * sp[27] + 1.885618083164156 * sp[30];
    A[189] = -33.33333333333351 * sp[33] + -46.66666666666688 * sp[34] + -6.66666666666663 * sp[28] + -6.66666666666671 * sp[31] + -26.66666666666677 * sp[34] + -36.66666666666687 * sp[35] + 3.333333333333234 * sp[29] + -6.666666666666803 * sp[32] + 13.33333333333347 * sp[28] + 3.333333333333336 * sp[29] + -36.66666666666664 * sp[26] + -46.66666666666674 * sp[27] + 13.33333333333348 * sp[31] + 13.33333333333333 * sp[32] + -26.66666666666684 * sp[27] + -33.33333333333357 * sp[30];
    A[190] = 28.57738033247015 * sp[33] + 8.164965809276778 * sp[34] + 8.164965809277474 * sp[28] + 8.164965809277202 * sp[31] + -4.082482904639184 * sp[34] + -22.45365597551272 * sp[35] + 26.53613888015096 * sp[29] + 8.164965809277026 * sp[32] + 69.40220937885672 * sp[28] + -22.45365597551264 * sp[29] + -71.44345083117605 * sp[26] + -89.81462390205006 * sp[27] + -4.082482904638992 * sp[31] + -28.57738033247039 * sp[32] + -53.0722777603026 * sp[27] + -69.40220937885718 * sp[30];
    A[191] = -58.92556509887916 * sp[33] + -18.85618083164143 * sp[34] + 37.71236166328276 * sp[28] + 37.71236166328266 * sp[31] + -25.92724864350691 * sp[34] + -22.39171473757424 * sp[35] + 34.17682775734988 * sp[29] + 37.71236166328266 * sp[32] + -40.06938426723754 * sp[28] + 5.892556509888074 * sp[29] + 5.892556509887848 * sp[26] + 9.428090415820691 * sp[27] + 2.357022603955293 * sp[31] + -11.78511301977589 * sp[32] + 2.357022603955108 * sp[27] + -2.357022603955032 * sp[30];
    A[192] = 66.66666666666683 * sp[33] + 33.33333333333349 * sp[34] + 33.33333333333312 * sp[28] + -6.666666666666833 * sp[31] + 33.33333333333349 * sp[34] + 33.33333333333334 * sp[35] + -6.666666666666691 * sp[29] + -6.666666666666705 * sp[32] + 33.33333333333312 * sp[28] + -6.666666666666691 * sp[29] + 113.3333333333333 * sp[26] + 33.33333333333342 * sp[27] + -6.666666666666833 * sp[31] + -6.666666666666705 * sp[32] + 33.33333333333342 * sp[27] + 26.66666666666698 * sp[30];
    A[193] = 12.24744871391604 * sp[34] + 12.24744871391598 * sp[28] + 12.24744871391592 * sp[31] + 36.7423461417476 * sp[34] + 24.49489742783166 * sp[35] + 24.49489742783168 * sp[29] + 12.24744871391579 * sp[32] + -110.2270384252433 * sp[28] + -48.98979485566376 * sp[29] + -48.98979485566374 * sp[26] + 36.74234614174742 * sp[27] + -36.74234614174789 * sp[31] + -36.74234614174814 * sp[32] + 12.24744871391588 * sp[27] + 24.49489742783153 * sp[30];
    A[194] = 117.8511301977582 * sp[33] + 58.92556509887915 * sp[34] + 58.92556509887889 * sp[28] + 2.357022603954989 * sp[31] + 58.92556509887922 * sp[34] + 58.92556509887893 * sp[35] + 2.357022603955237 * sp[29] + 2.357022603954572 * sp[32] + 58.92556509887861 * sp[28] + -11.78511301977585 * sp[29] + 44.78342947514781 * sp[26] + -11.78511301977582 * sp[27] + -11.78511301977606 * sp[31] + -11.78511301977584 * sp[32] + -11.78511301977595 * sp[27] + -9.428090415820931 * sp[30];
    A[195] = -16.88749537379662 * sp[33] + -5.196152422706676 * sp[34] + 5.196152422706658 * sp[28] + 5.196152422706625 * sp[31] + -7.361215932167756 * sp[34] + -6.278684177437277 * sp[35] + 11.90784930203618 * sp[29] + 5.196152422706669 * sp[32] + -7.361215932167761 * sp[28] + 4.979646071760504 * sp[29] + -21.86714144555712 * sp[26] + -1.732050807568864 * sp[27] + 3.897114317029959 * sp[31] + 3.897114317029938 * sp[32] + -15.1554445662276 * sp[27] + -3.897114317029913 * sp[30];
    A[196] = 7.794228634059974 * sp[33] + -2.598076211353278 * sp[34] + 2.598076211353308 * sp[28] + 2.598076211353373 * sp[31] + 1.732050807568875 * sp[34] + -0.433012701892129 * sp[35] + -2.165063509461179 * sp[29] + 2.598076211353393 * sp[32] + 1.732050807568886 * sp[28] + -5.629165124598755 * sp[29] + 13.42339375865882 * sp[26] + -0.8660254037845494 * sp[27] + -3.464101615137751 * sp[31] + -3.464101615137691 * sp[32] + 8.660254037844366 * sp[27] + -5.196152422706595 * sp[30];
    A[197] = -3.897114317029996 * sp[33] + -5.196152422706642 * sp[34] + 5.196152422706636 * sp[28] + 5.196152422706606 * sp[31] + -3.031088913245559 * sp[34] + -4.113620667976122 * sp[35] + 5.412658773652778 * sp[29] + 5.196152422706595 * sp[32] + -3.031088913245561 * sp[28] + -1.515544456622848 * sp[29] + -2.381569860407204 * sp[26] + -1.732050807568826 * sp[27] + -0.4330127018922304 * sp[31] + -0.4330127018922533 * sp[32] + -2.165063509461083 * sp[27] + 0.4330127018921799 * sp[30];
    A[198] = 16.88749537379659 * sp[33] + 11.69134295108993 * sp[34] + 22.08364779650326 * sp[28] + 11.69134295108996 * sp[31] + 9.526279441628855 * sp[34] + 10.60881119635943 * sp[35] + 2.81458256229944 * sp[29] + 3.897114317029994 * sp[32] + 9.526279441628857 * sp[28] + -0.649519052838321 * sp[29] + 36.58957330989253 * sp[26] + 19.48557158514986 * sp[27] + -1.73205080756885 * sp[31] + -1.732050807568852 * sp[32] + -1.732050807568892 * sp[27] + 0.4330127018922139 * sp[30];
    A[199] = -7.794228634059968 * sp[33] + -10.39230484541327 * sp[34] + -5.196152422706653 * sp[28] + -10.39230484541322 * sp[31] + -6.062177826491103 * sp[34] + -8.227241335952202 * sp[35] + -1.299038105676681 * sp[29] + -3.464101615137734 * sp[32] + -6.0621778264911 * sp[28] + -3.0310889132456 * sp[29] + -16.8874953737965 * sp[26] + -17.32050807568876 * sp[27] + -0.8660254037844608 * sp[31] + -0.8660254037844691 * sp[32] + -0.8660254037844297 * sp[27] + 3.464101615137786 * sp[30];
    A[200] = 3.89711431702998 * sp[33] + -1.299038105676636 * sp[34] + 9.093266739736629 * sp[28] + -1.29903810567663 * sp[31] + 0.8660254037844366 * sp[34] + -0.216506350946049 * sp[35] + 0.6495190528383099 * sp[29] + -0.4330127018921675 * sp[32] + 0.8660254037844356 * sp[28] + -2.814582562299335 * sp[29] + 8.443747686898275 * sp[26] + -2.165063509461003 * sp[27] + -1.732050807568875 * sp[31] + -1.732050807568823 * sp[32] + -1.732050807568875 * sp[27] + -3.897114317029974 * sp[30];
    A[201] = 10.39230484541328 * sp[33] + 11.69134295108993 * sp[34] + 11.69134295108993 * sp[28] + 11.69134295108992 * sp[31] + 7.361215932167783 * sp[34] + 6.062177826491048 * sp[35] + 12.99038105676665 * sp[29] + 11.69134295108996 * sp[32] + 7.361215932167664 * sp[28] + 12.99038105676653 * sp[29] + -7.794228634059947 * sp[26] + -3.897114317029989 * sp[27] + -6.495190528383258 * sp[31] + -8.227241335952186 * sp[32] + -6.495190528383226 * sp[27] + -6.062177826491047 * sp[30];
    A[202] = -20.7846096908266 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541328 * sp[28] + -10.39230484541325 * sp[31] + -10.39230484541338 * sp[34] + -3.464101615137786 * sp[35] + -17.32050807568892 * sp[29] + -10.39230484541332 * sp[32] + -10.39230484541324 * sp[28] + -17.32050807568875 * sp[29] + 24.24871130596432 * sp[26] + 3.464101615137766 * sp[27] + 17.3205080756887 * sp[31] + 3.464101615137676 * sp[32] + 17.32050807568866 * sp[27] + 7.794228634059841 * sp[30];
    A[203] = 10.39230484541332 * sp[33] + -1.299038105676696 * sp[34] + -1.299038105676656 * sp[28] + -1.299038105676712 * sp[31] + 3.031088913245604 * sp[34] + -2.598076211353357 * sp[35] + 4.330127018922282 * sp[29] + -1.299038105676709 * sp[32] + 3.031088913245543 * sp[28] + 4.330127018922271 * sp[29] + -16.45448267190437 * sp[26] + 0.4330127018922959 * sp[27] + -10.82531754730545 * sp[31] + 4.763139720814385 * sp[32] + -10.82531754730544 * sp[27] + 2.598076211353327 * sp[30];
    A[204] = -36.7423461417478 * sp[33] + -36.7423461417476 * sp[34] + 36.74234614174773 * sp[28] + 36.74234614174784 * sp[31] + -24.49489742783193 * sp[34] + -30.61862178478958 * sp[35] + 42.86607049870585 * sp[29] + 36.74234614174809 * sp[32] + -24.4948974278319 * sp[28] + -6.123724356958125 * sp[29] + -30.61862178478978 * sp[26] + -12.24744871391626 * sp[27] + -24.49489742783155 * sp[27] + -36.7423461417473 * sp[30];
    A[205] = -67.50000000000031 * sp[33] + 90.00000000000014 * sp[28] + 90.0000000000003 * sp[31] + 7.500000000000174 * sp[34] + 3.750000000000099 * sp[35] + 93.75000000000043 * sp[29] + 90.00000000000068 * sp[32] + 7.499999999998977 * sp[28] + 48.74999999999937 * sp[29] + -41.24999999999994 * sp[26] + -30.00000000000053 * sp[27] + 52.50000000000026 * sp[31] + -22.49999999999978 * sp[32] + -37.49999999999953 * sp[27] + -67.49999999999953 * sp[30];
    A[206] = 12.99038105676654 * sp[33] + -25.98076211353329 * sp[34] + 25.98076211353312 * sp[28] + 25.98076211353295 * sp[31] + -4.330127018922303 * sp[34] + 10.82531754730554 * sp[35] + 10.82531754730538 * sp[29] + 25.98076211353277 * sp[32] + -4.330127018922363 * sp[28] + 2.16506350946057 * sp[29] + 36.80607966083878 * sp[26] + -8.660254037844052 * sp[27] + -12.99038105676661 * sp[31] + 12.99038105676643 * sp[32] + 21.65063509461088 * sp[27] + 12.99038105676612 * sp[30];
    A[207] = 36.7423461417476 * sp[34] + -110.2270384252433 * sp[28] + -36.74234614174789 * sp[31] + 12.24744871391604 * sp[34] + 24.49489742783166 * sp[35] + -48.98979485566376 * sp[29] + -36.74234614174814 * sp[32] + 12.24744871391598 * sp[28] + 24.49489742783168 * sp[29] + -48.98979485566374 * sp[26] + 12.24744871391588 * sp[27] + 12.24744871391592 * sp[31] + 12.24744871391579 * sp[32] + 36.74234614174742 * sp[27] + 24.49489742783153 * sp[30];
    A[208] = 135.0000000000004 * sp[33] + 67.50000000000021 * sp[34] + 67.50000000000023 * sp[28] + -22.49999999999986 * sp[31] + 67.50000000000021 * sp[34] + 67.50000000000051 * sp[35] + -22.50000000000014 * sp[29] + -22.49999999999986 * sp[32] + 67.50000000000023 * sp[28] + -22.50000000000014 * sp[29] + 247.4999999999995 * sp[26] + 67.49999999999991 * sp[27] + -22.49999999999986 * sp[31] + -22.49999999999986 * sp[32] + 67.49999999999991 * sp[27] + 59.99999999999989 * sp[30];
    A[209] = 64.95190528383273 * sp[34] + -38.97114317029975 * sp[28] + 12.99038105676649 * sp[31] + 21.65063509461118 * sp[34] + 43.30127018922168 * sp[35] + -8.660254037844108 * sp[29] + 12.99038105676672 * sp[32] + 21.65063509461118 * sp[28] + 43.30127018922178 * sp[29] + -8.660254037844613 * sp[26] + 99.5929214352094 * sp[27] + 21.65063509461104 * sp[31] + 21.6506350946108 * sp[32] + -12.99038105676658 * sp[27] + 43.30127018922244 * sp[30];
    A[210] = 10.41666666666663 * sp[33] + -5.833333333333385 * sp[34] + 0.8333333333333558 * sp[28] + 0.8333333333334065 * sp[31] + -2.916666666666666 * sp[34] + -4.375000000000012 * sp[35] + -3.541666666666703 * sp[29] + 0.8333333333333348 * sp[32] + 10.08333333333331 * sp[28] + -2.875000000000033 * sp[29] + 7.958333333333417 * sp[26] + 1.833333333333387 * sp[27] + -1.41666666666667 * sp[31] + -1.416666666666769 * sp[32] + 3.583333333333353 * sp[27] + 2.916666666666667 * sp[30];
    A[211] = -20.83333333333333 * sp[33] + 15.83333333333341 * sp[34] + -5.833333333333364 * sp[28] + -5.833333333333445 * sp[31] + -6.66666666666668 * sp[34] + 4.583333333333425 * sp[35] + 2.916666666666657 * sp[29] + -5.833333333333408 * sp[32] + -12.66666666666664 * sp[28] + 11.58333333333335 * sp[29] + -10.08333333333339 * sp[26] + 2.166666666666613 * sp[27] + 0.3333333333333609 * sp[31] + 0.3333333333335431 * sp[32] + -1.333333333333366 * sp[27] + 13.33333333333324 * sp[30];
    A[212] = -10.41666666666672 * sp[33] + -30.83333333333347 * sp[34] + 9.166666666666737 * sp[28] + 9.166666666666728 * sp[31] + -7.083333333333361 * sp[34] + -18.95833333333342 * sp[35] + 6.875000000000005 * sp[29] + 9.1666666666667 * sp[32] + -4.083333333333338 * sp[28] + -12.45833333333336 * sp[29] + 3.375000000000049 * sp[26] + 0.1666666666666941 * sp[27] + -0.5833333333333198 * sp[31] + -0.5833333333333895 * sp[32] + 1.083333333333323 * sp[27] + -12.91666666666668 * sp[30];
    A[213] = 10.41666666666675 * sp[33] + 16.25000000000009 * sp[34] + 9.583333333333385 * sp[28] + 16.25000000000001 * sp[31] + 13.33333333333335 * sp[34] + 14.79166666666665 * sp[35] + 8.958333333333391 * sp[29] + 10.41666666666667 * sp[32] + 0.3333333333333535 * sp[28] + 3.291666666666715 * sp[29] + 7.458333333333296 * sp[26] + 9.416666666666629 * sp[27] + 1.833333333333299 * sp[31] + 1.833333333333328 * sp[32] + 1.833333333333275 * sp[27] + 2.916666666666611 * sp[30];
    A[214] = -20.83333333333342 * sp[33] + -36.66666666666683 * sp[34] + -14.99999999999998 * sp[28] + -36.66666666666671 * sp[31] + -14.1666666666667 * sp[34] + -25.41666666666674 * sp[35] + -5.416666666666674 * sp[29] + -16.66666666666674 * sp[32] + -8.166666666666673 * sp[28] + -12.4166666666667 * sp[29] + -12.41666666666661 * sp[26] + -24.66666666666663 * sp[27] + -1.166666666666629 * sp[31] + -1.166666666666665 * sp[32] + -1.166666666666607 * sp[27] + 10.00000000000006 * sp[30];
    A[215] = -10.41666666666665 * sp[33] + 20.41666666666677 * sp[34] + -19.58333333333335 * sp[28] + 20.41666666666674 * sp[31] + -3.333333333333336 * sp[34] + 8.541666666666767 * sp[35] + -5.625000000000007 * sp[29] + 6.250000000000144 * sp[32] + -6.333333333333308 * sp[28] + 12.04166666666667 * sp[29] + -12.12500000000001 * sp[26] + 15.24999999999998 * sp[27] + 0.1666666666666781 * sp[31] + 0.1666666666668162 * sp[32] + 0.1666666666666778 * sp[27] + -12.91666666666645 * sp[30];
    A[216] = 4.166666666666634 * sp[33] + 7.083333333333233 * sp[34] + 7.083333333333406 * sp[28] + 7.083333333333359 * sp[31] + 0.4166666666666234 * sp[34] + -0.4166666666666714 * sp[35] + 7.916666666666639 * sp[29] + 7.083333333333311 * sp[32] + 8.416666666666657 * sp[28] + 13.58333333333324 * sp[29] + 1.916666666666728 * sp[26] + 3.083333333333355 * sp[27] + 2.749999999999958 * sp[31] + -8.916666666666851 * sp[32] + 2.749999999999981 * sp[27] + -3.333333333333425 * sp[30];
    A[217] = -1.666666666666673 * sp[34] + -1.666666666666707 * sp[28] + -1.666666666666725 * sp[31] + 3.333333333333329 * sp[34] + 0.8333333333333437 * sp[35] + 0.8333333333333925 * sp[29] + -1.666666666666642 * sp[32] + -12.66666666666669 * sp[28] + -7.166666666666639 * sp[29] + -7.166666666666769 * sp[26] + -3.666666666666709 * sp[27] + -4.666666666666671 * sp[31] + -7.99999999999992 * sp[32] + -4.666666666666679 * sp[27] + -5.833333333333265 * sp[30];
    A[218] = -4.166666666666643 * sp[33] + 2.91666666666679 * sp[34] + 2.916666666666681 * sp[28] + 2.916666666666761 * sp[31] + -3.749999999999957 * sp[34] + 3.750000000000098 * sp[35] + -4.583333333333345 * sp[29] + 2.916666666666718 * sp[32] + 4.250000000000017 * sp[28] + -2.24999999999996 * sp[29] + 9.416666666666732 * sp[26] + -1.08333333333329 * sp[27] + 1.916666666666697 * sp[31] + -13.0833333333332 * sp[32] + 1.916666666666698 * sp[27] + -6.666666666666607 * sp[30];
    A[219] = -58.92556509887925 * sp[33] + -82.4957911384309 * sp[34] + -11.78511301977576 * sp[28] + -11.7851130197759 * sp[31] + -47.14045207910328 * sp[34] + -64.81812160876716 * sp[35] + 5.892556509887728 * sp[29] + -11.78511301977604 * sp[32] + -18.85618083164128 * sp[28] + -22.39171473757409 * sp[29] + -8.24957911384295 * sp[26] + 16.4991582276861 * sp[27] + -4.714045207910239 * sp[31] + 80.13876853447539 * sp[32] + 9.428090415820565 * sp[27] + 54.21151989096814 * sp[30];
    A[220] = 50.51814855409177 * sp[33] + 14.43375672973979 * sp[34] + 14.43375672974096 * sp[28] + 14.43375672974047 * sp[31] + -7.216878364871278 * sp[34] + -39.6928310067872 * sp[35] + 46.90970937165683 * sp[29] + 14.43375672974019 * sp[32] + 44.74464586219586 * sp[28] + 72.89047148518966 * sp[29] + -13.71206889325335 * sp[26] + 31.75426480542946 * sp[27] + 105.3664241271056 * sp[31] + 62.06515393788342 * sp[32] + 18.76388374866266 * sp[27] + 50.51814855409141 * sp[30];
    A[221] = -104.166666666667 * sp[33] + -33.33333333333361 * sp[34] + 66.66666666666703 * sp[28] + 66.66666666666688 * sp[31] + -45.83333333333357 * sp[34] + -39.58333333333363 * sp[35] + 60.41666666666676 * sp[29] + 66.66666666666687 * sp[32] + -55.83333333333333 * sp[28] + 5.416666666666618 * sp[29] + 5.416666666666783 * sp[26] + -3.333333333333266 * sp[27] + -0.8333333333332065 * sp[31] + -25.8333333333336 * sp[32] + -0.833333333333437 * sp[27] + -104.1666666666667 * sp[30];
    A[222] = 117.8511301977582 * sp[33] + 58.92556509887922 * sp[34] + 58.92556509887861 * sp[28] + -11.78511301977606 * sp[31] + 58.92556509887915 * sp[34] + 58.92556509887893 * sp[35] + -11.78511301977585 * sp[29] + -11.78511301977584 * sp[32] + 58.92556509887889 * sp[28] + 2.357022603955237 * sp[29] + 44.78342947514781 * sp[26] + -11.78511301977595 * sp[27] + 2.357022603954989 * sp[31] + 2.357022603954572 * sp[32] + -11.78511301977582 * sp[27] + -9.428090415820931 * sp[30];
    A[223] = 21.65063509461118 * sp[34] + 21.65063509461118 * sp[28] + 21.65063509461104 * sp[31] + 64.95190528383273 * sp[34] + 43.30127018922168 * sp[35] + 43.30127018922178 * sp[29] + 21.6506350946108 * sp[32] + -38.97114317029975 * sp[28] + -8.660254037844108 * sp[29] + -8.660254037844613 * sp[26] + -12.99038105676658 * sp[27] + 12.99038105676649 * sp[31] + 12.99038105676672 * sp[32] + 99.5929214352094 * sp[27] + 43.30127018922244 * sp[30];
    A[224] = 208.3333333333338 * sp[33] + 104.166666666667 * sp[34] + 104.1666666666665 * sp[28] + 4.166666666666352 * sp[31] + 104.166666666667 * sp[34] + 104.1666666666665 * sp[35] + 4.166666666666737 * sp[29] + 4.166666666665634 * sp[32] + 104.1666666666665 * sp[28] + 4.166666666666737 * sp[29] + 104.1666666666665 * sp[26] + 4.166666666666574 * sp[27] + 4.166666666666352 * sp[31] + 4.166666666665634 * sp[32] + 4.166666666666574 * sp[27] + 183.3333333333316 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698436 * sp[19] + -0.01116071428571437 * sp[18] + -0.01116071428571437 * sp[18] + 0.05734126984127028 * sp[17];
    A[1] = -0.02986111111111126 * sp[19] + 0.005952380952380924 * sp[18] + 0.009920634920634995 * sp[18] + -0.04871031746031773 * sp[17];
    A[2] = 0.01765873015873015 * sp[19] + -0.004712301587301571 * sp[18] + -0.00471230158730161 * sp[18] + 0.01765873015873018 * sp[17];
    A[3] = -0.01542658730158742 * sp[19] + -0.02447916666666681 * sp[18] + 0.009052579365079399 * sp[18] + 0.01860119047619068 * sp[17];
    A[4] = 0.01746031746031742 * sp[19] + 0.02167658730158721 * sp[18] + -0.00570436507936509 * sp[18] + -0.01190476190476195 * sp[17];
    A[5] = -0.02385912698412703 * sp[19] + -0.0326636904761906 * sp[18] + 0.00682043650793656 * sp[18] + 0.0111607142857142 * sp[17];
    A[6] = -0.01314484126984127 * sp[19] + -0.008804563492063535 * sp[18] + 0.03067956349206367 * sp[18] + 0.02385912698412708 * sp[17];
    A[7] = 0.02777777777777799 * sp[19] + 0.01413690476190487 * sp[18] + -0.07276785714285776 * sp[18] + -0.06111111111111156 * sp[17];
    A[8] = -0.02058531746031763 * sp[19] + -0.007068452380952384 * sp[18] + 0.05820932539682568 * sp[18] + 0.05114087301587336 * sp[17];
    A[9] = 0.04349267900155118 * sp[19] + -0.02314932914598858 * sp[18] + -0.06243303921190634 * sp[18] + 0.03507474113028572 * sp[17];
    A[10] = 0.06529556615835226 * sp[19] + -0.05154913117764575 * sp[18] + -0.1271545235715238 * sp[18] + 0.06529556615835093 * sp[17];
    A[11] = -0.01686507936508155 * sp[19] + -0.007440476190475894 * sp[18] + 0.07192460317460256 * sp[18] + -0.01091269841269933 * sp[17];
    A[12] = 0.0350747411302857 * sp[19] + 0.1283735525368425 * sp[18] + -0.01192541198429703 * sp[18] + -0.1248660784238149 * sp[17];
    A[13] = -0.1005208057964094 * sp[19] + -0.06314768569261546 * sp[18] + 0.07088005536926253 * sp[18] + -0.08505606644311359 * sp[17];
    A[14] = 0.06200396825396932 * sp[19] + 0.09598214285714173 * sp[18] + -0.02108134920634947 * sp[18] + 0.05307539682539843 * sp[17];
    A[15] = -0.02986111111111126 * sp[19] + 0.009920634920634995 * sp[18] + 0.005952380952380924 * sp[18] + -0.04871031746031773 * sp[17];
    A[16] = 0.068650793650794 * sp[19] + -0.01289682539682547 * sp[18] + -0.01289682539682547 * sp[18] + 0.06865079365079424 * sp[17];
    A[17] = -0.04871031746031763 * sp[19] + 0.005952380952380895 * sp[18] + 0.009920634920634976 * sp[18] + -0.02986111111111135 * sp[17];
    A[18] = 0.01746031746031743 * sp[19] + 0.02316468253968252 * sp[18] + -0.004216269841269777 * sp[18] + -0.01041666666666671 * sp[17];
    A[19] = -0.04384920634920639 * sp[19] + -0.05327380952380968 * sp[18] + 0.009424603174603195 * sp[18] + 0.01785714285714291 * sp[17];
    A[20] = 0.06111111111111139 * sp[19] + 0.0752480158730163 * sp[18] + -0.01165674603174613 * sp[18] + -0.02529761904761914 * sp[17];
    A[21] = 0.01041666666666665 * sp[19] + 0.004216269841269741 * sp[18] + -0.02316468253968258 * sp[18] + -0.01746031746031744 * sp[17];
    A[22] = -0.01785714285714292 * sp[19] + -0.009424603174603204 * sp[18] + 0.05327380952380984 * sp[18] + 0.04384920634920653 * sp[17];
    A[23] = 0.02529761904761927 * sp[19] + 0.01165674603174613 * sp[18] + -0.07524801587301647 * sp[18] + -0.06111111111111164 * sp[17];
    A[24] = -0.07856742013183729 * sp[19] + -0.009820927516479861 * sp[18] + 0.1360899955855054 * sp[18] + 0.07014948226057126 * sp[17];
    A[25] = -0.05326743555023482 * sp[19] + -0.008591521862941593 * sp[18] + 0.1838585678669349 * sp[18] + 0.08419691425682259 * sp[17];
    A[26] = -0.004960317460314449 * sp[19] + 0.01984126984126932 * sp[18] + -0.162698412698412 * sp[18] + -0.1021825396825407 * sp[17];
    A[27] = -0.07014948226057131 * sp[19] + -0.1360899955855055 * sp[18] + 0.009820927516479946 * sp[18] + 0.07856742013183721 * sp[17];
    A[28] = 0.04639421805988039 * sp[19] + 0.04897167461876194 * sp[18] + -0.0128872827944107 * sp[18] + 0.03092947870658564 * sp[17];
    A[29] = -0.1240079365079386 * sp[19] + -0.2405753968253962 * sp[18] + 0.01736111111111141 * sp[18] + 0.04365079365079547 * sp[17];
    A[30] = 0.01765873015873015 * sp[19] + -0.00471230158730161 * sp[18] + -0.004712301587301571 * sp[18] + 0.01765873015873018 * sp[17];
    A[31] = -0.04871031746031763 * sp[19] + 0.009920634920634976 * sp[18] + 0.005952380952380895 * sp[18] + -0.02986111111111135 * sp[17];
    A[32] = 0.05734126984127028 * sp[19] + -0.01116071428571434 * sp[18] + -0.01116071428571434 * sp[18] + 0.02162698412698439 * sp[17];
    A[33] = -0.0238591269841271 * sp[19] + -0.0306795634920637 * sp[18] + 0.008804563492063541 * sp[18] + 0.0131448412698413 * sp[17];
    A[34] = 0.06111111111111155 * sp[19] + 0.07276785714285781 * sp[18] + -0.01413690476190486 * sp[18] + -0.02777777777777799 * sp[17];
    A[35] = -0.05114087301587328 * sp[19] + -0.05820932539682568 * sp[18] + 0.007068452380952367 * sp[18] + 0.02058531746031755 * sp[17];
    A[36] = -0.01860119047619065 * sp[19] + -0.009052579365079387 * sp[18] + 0.02447916666666685 * sp[18] + 0.01542658730158743 * sp[17];
    A[37] = 0.01190476190476195 * sp[19] + 0.005704365079365086 * sp[18] + -0.0216765873015873 * sp[18] + -0.01746031746031748 * sp[17];
    A[38] = -0.0111607142857143 * sp[19] + -0.006820436507936542 * sp[18] + 0.03266369047619069 * sp[18] + 0.02385912698412714 * sp[17];
    A[39] = 0.1248660784238152 * sp[19] + 0.01192541198429695 * sp[18] + -0.1283735525368425 * sp[18] + -0.03507474113028571 * sp[17];
    A[40] = -0.003436608745177813 * sp[19] + -0.01718304372588163 * sp[18] + -0.05154913117764449 * sp[18] + -0.003436608745176723 * sp[17];
    A[41] = 0.1001984126984121 * sp[19] + -0.07192460317460356 * sp[18] + 0.1026785714285714 * sp[18] + 0.1180555555555573 * sp[17];
    A[42] = -0.03507474113028577 * sp[19] + 0.06243303921190652 * sp[18] + 0.02314932914598859 * sp[18] + -0.04349267900155117 * sp[17];
    A[43] = -0.02319710902993973 * sp[19] + 0.001288728279440923 * sp[18] + 0.03221820698602828 * sp[18] + -0.01804219591217504 * sp[17];
    A[44] = -0.06200396825396937 * sp[19] + 0.1460813492063478 * sp[18] + 0.04092261904761976 * sp[18] + -0.06498015873016073 * sp[17];
    A[45] = -0.01542658730158742 * sp[19] + 0.009052579365079399 * sp[18] + -0.02447916666666681 * sp[18] + 0.01860119047619068 * sp[17];
    A[46] = 0.01746031746031743 * sp[19] + -0.004216269841269777 * sp[18] + 0.02316468253968252 * sp[18] + -0.01041666666666671 * sp[17];
    A[47] = -0.0238591269841271 * sp[19] + 0.008804563492063541 * sp[18] + -0.0306795634920637 * sp[18] + 0.0131448412698413 * sp[17];
    A[48] = 0.02162698412698433 * sp[19] + 0.03278769841269868 * sp[18] + 0.03278769841269868 * sp[18] + 0.1012896825396832 * sp[17];
    A[49] = -0.0298611111111113 * sp[19] + -0.03581349206349223 * sp[18] + -0.03978174603174633 * sp[18] + -0.09444444444444483 * sp[17];
    A[50] = 0.01765873015873015 * sp[19] + 0.02237103174603172 * sp[18] + 0.02237103174603176 * sp[18] + 0.0447420634920634 * sp[17];
    A[51] = 0.02058531746031756 * sp[19] + 0.01351686507936519 * sp[18] + 0.07879464285714317 * sp[18] + 0.02058531746031759 * sp[17];
    A[52] = -0.02777777777777796 * sp[19] + -0.01364087301587309 * sp[18] + -0.1005456349206356 * sp[18] + -0.02529761904761929 * sp[17];
    A[53] = 0.01314484126984128 * sp[19] + 0.004340277777777722 * sp[18] + 0.0438244047619049 * sp[18] + 0.01116071428571435 * sp[17];
    A[54] = -0.0785674201318369 * sp[19] + 0.02665680325901711 * sp[18] + -0.1529258713280409 * sp[18] + 0.04208968935634283 * sp[17];
    A[55] = -0.03522523963805743 * sp[19] + 0.07947157723220399 * sp[18] + 0.02104922856420364 * sp[18] + 0.1159855451497028 * sp[17];
    A[56] = -0.04513888888888819 * sp[19] + 0.04340277777777804 * sp[18] + 0.005704365079364414 * sp[18] + 0.05208333333333301 * sp[17];
    A[57] = 0.03507474113028566 * sp[19] + -0.09329881140655678 * sp[18] + 0.04700015311458292 * sp[18] + -0.206239477846075 * sp[17];
    A[58] = 0.1005208057964093 * sp[19] + 0.03737312010379358 * sp[18] + 0.1714008611656716 * sp[18] + 0.193309241916169 * sp[17];
    A[59] = 0.06200396825396924 * sp[19] + -0.03397817460317279 * sp[18] + 0.08308531746031904 * sp[18] + 0.04017857142857455 * sp[17];
    A[60] = 0.01746031746031742 * sp[19] + -0.00570436507936509 * sp[18] + 0.02167658730158721 * sp[18] + -0.01190476190476195 * sp[17];
    A[61] = -0.04384920634920639 * sp[19] + 0.009424603174603195 * sp[18] + -0.05327380952380968 * sp[18] + 0.01785714285714291 * sp[17];
    A[62] = 0.06111111111111155 * sp[19] + -0.01413690476190486 * sp[18] + 0.07276785714285781 * sp[18] + -0.02777777777777799 * sp[17];
    A[63] = -0.0298611111111113 * sp[19] + -0.03978174603174633 * sp[18] + -0.03581349206349223 * sp[18] + -0.09444444444444483 * sp[17];
    A[64] = 0.0686507936507942 * sp[19] + 0.08154761904761976 * sp[18] + 0.08154761904761976 * sp[18] + 0.1630952380952395 * sp[17];
    A[65] = -0.04871031746031765 * sp[19] + -0.05466269841269858 * sp[18] + -0.05863095238095271 * sp[18] + -0.09444444444444487 * sp[17];
    A[66] = -0.02529761904761927 * sp[19] + -0.0136408730158731 * sp[18] + -0.1005456349206356 * sp[18] + -0.02777777777777798 * sp[17];
    A[67] = 0.01785714285714292 * sp[19] + 0.008432539682539694 * sp[18] + 0.07113095238095249 * sp[18] + 0.01785714285714292 * sp[17];
    A[68] = -0.01041666666666661 * sp[19] + -0.00620039682539682 * sp[18] + -0.03358134920634904 * sp[18] + -0.01190476190476189 * sp[17];
    A[69] = 0.1487169023924089 * sp[19] + 0.002805979290422722 * sp[18] + 0.2946278254943949 * sp[18];
    A[70] = -0.006873217490354661 * sp[19] + -0.04725337024617508 * sp[18] + -0.1778445025628794 * sp[18] + -0.1030982623552913 * sp[17];
    A[71] = 0.1289682539682536 * sp[19] + -0.09176587301587369 * sp[18] + -0.01636904761904652 * sp[18] + -0.1785714285714299 * sp[17];
    A[72] = -0.07014948226057144 * sp[19] + 0.06594051332493446 * sp[18] + -0.07997040977705143 * sp[18] + 0.134687005940292 * sp[17];
    A[73] = -0.04639421805988034 * sp[19] + 0.002577456558881674 * sp[18] + -0.0592815008542907 * sp[18] + -0.04123930494211438 * sp[17];
    A[74] = -0.1240079365079386 * sp[19] + 0.1165674603174581 * sp[18] + -0.14136904761905 * sp[18] + 0.1428571428571432 * sp[17];
    A[75] = -0.02385912698412703 * sp[19] + 0.00682043650793656 * sp[18] + -0.0326636904761906 * sp[18] + 0.0111607142857142 * sp[17];
    A[76] = 0.06111111111111139 * sp[19] + -0.01165674603174613 * sp[18] + 0.0752480158730163 * sp[18] + -0.02529761904761914 * sp[17];
    A[77] = -0.05114087301587328 * sp[19] + 0.007068452380952367 * sp[18] + -0.05820932539682568 * sp[18] + 0.02058531746031755 * sp[17];
    A[78] = 0.01765873015873015 * sp[19] + 0.02237103174603176 * sp[18] + 0.02237103174603172 * sp[18] + 0.0447420634920634 * sp[17];
    A[79] = -0.04871031746031765 * sp[19] + -0.05863095238095271 * sp[18] + -0.05466269841269858 * sp[18] + -0.09444444444444487 * sp[17];
    A[80] = 0.05734126984127013 * sp[19] + 0.06850198412698452 * sp[18] + 0.06850198412698452 * sp[18] + 0.1012896825396832 * sp[17];
    A[81] = 0.01116071428571431 * sp[19] + 0.004340277777777702 * sp[18] + 0.04382440476190484 * sp[18] + 0.01314484126984122 * sp[17];
    A[82] = -0.01190476190476192 * sp[19] + -0.006200396825396829 * sp[18] + -0.03358134920634897 * sp[18] + -0.01041666666666652 * sp[17];
    A[83] = 0.01860119047619062 * sp[19] + 0.009548611111111204 * sp[18] + 0.04308035714285731 * sp[18] + 0.01860119047619051 * sp[17];
    A[84] = -0.08979133729352939 * sp[19] + -0.01543288609732559 * sp[18] + -0.1950155606843832 * sp[18] + -0.04208968935634264 * sp[17];
    A[85] = -0.02663371777511721 * sp[19] + -0.01073940232867682 * sp[18] + -0.007302793583500541 * sp[18] + -0.0128872827944123 * sp[17];
    A[86] = -0.03819444444444239 * sp[19] + 0.0359623015873014 * sp[18] + 0.1054067460317488 * sp[18] + 0.1264880952380962 * sp[17];
    A[87] = -0.03507474113028559 * sp[19] + -0.09750778034219186 * sp[18] + -0.05822407027627423 * sp[18] + -0.1641497884897315 * sp[17];
    A[88] = 0.02319710902993964 * sp[19] + 0.02448583730938055 * sp[18] + 0.05541531601596784 * sp[18] + 0.07474624020758397 * sp[17];
    A[89] = -0.06200396825396918 * sp[19] + -0.2080853174603167 * sp[18] + -0.102926587301589 * sp[18] + -0.3139880952380974 * sp[17];
    A[90] = -0.01314484126984127 * sp[19] + 0.03067956349206367 * sp[18] + -0.008804563492063535 * sp[18] + 0.02385912698412708 * sp[17];
    A[91] = 0.01041666666666665 * sp[19] + -0.02316468253968258 * sp[18] + 0.004216269841269741 * sp[18] + -0.01746031746031744 * sp[17];
    A[92] = -0.01860119047619065 * sp[19] + 0.02447916666666685 * sp[18] + -0.009052579365079387 * sp[18] + 0.01542658730158743 * sp[17];
    A[93] = 0.02058531746031756 * sp[19] + 0.07879464285714317 * sp[18] + 0.01351686507936519 * sp[18] + 0.02058531746031759 * sp[17];
    A[94] = -0.02529761904761927 * sp[19] + -0.1005456349206356 * sp[18] + -0.0136408730158731 * sp[18] + -0.02777777777777798 * sp[17];
    A[95] = 0.01116071428571431 * sp[19] + 0.04382440476190484 * sp[18] + 0.004340277777777702 * sp[18] + 0.01314484126984122 * sp[17];
    A[96] = 0.1012896825396832 * sp[19] + 0.03278769841269869 * sp[18] + 0.03278769841269869 * sp[18] + 0.02162698412698432 * sp[17];
    A[97] = -0.0944444444444448 * sp[19] + -0.03978174603174627 * sp[18] + -0.03581349206349219 * sp[18] + -0.02986111111111125 * sp[17];
    A[98] = 0.0447420634920634 * sp[19] + 0.02237103174603177 * sp[18] + 0.0223710317460317 * sp[18] + 0.01765873015873014 * sp[17];
    A[99] = -0.2062394778460752 * sp[19] + 0.04700015311458275 * sp[18] + -0.09329881140655683 * sp[18] + 0.03507474113028559 * sp[17];
    A[100] = 0.1314502845029981 * sp[19] + 0.1576544261849666 * sp[18] + -0.0107394023286741 * sp[18] + 0.1039574145415858 * sp[17];
    A[101] = 0.1473214285714274 * sp[19] + 0.1068948412698421 * sp[18] + 0.04935515873015868 * sp[18] + 0.05605158730158797 * sp[17];
    A[102] = 0.04208968935634284 * sp[19] + -0.1529258713280408 * sp[18] + 0.02665680325901718 * sp[18] + -0.07856742013183672 * sp[17];
    A[103] = 0.1030982623552904 * sp[19] + 0.01546473935329245 * sp[18] + 0.0773236967664685 * sp[18] + -0.05670404429540906 * sp[17];
    A[104] = 0.07440476190476315 * sp[19] + 0.01537698412698339 * sp[18] + 0.04712301587301671 * sp[18] + -0.007936507936507952 * sp[17];
    A[105] = 0.02777777777777799 * sp[19] + -0.07276785714285776 * sp[18] + 0.01413690476190487 * sp[18] + -0.06111111111111156 * sp[17];
    A[106] = -0.01785714285714292 * sp[19] + 0.05327380952380984 * sp[18] + -0.009424603174603204 * sp[18] + 0.04384920634920653 * sp[17];
    A[107] = 0.01190476190476195 * sp[19] + -0.0216765873015873 * sp[18] + 0.005704365079365086 * sp[18] + -0.01746031746031748 * sp[17];
    A[108] = -0.02777777777777796 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587309 * sp[18] + -0.02529761904761929 * sp[17];
    A[109] = 0.01785714285714292 * sp[19] + 0.07113095238095249 * sp[18] + 0.008432539682539694 * sp[18] + 0.01785714285714292 * sp[17];
    A[110] = -0.01190476190476192 * sp[19] + -0.03358134920634897 * sp[18] + -0.006200396825396829 * sp[18] + -0.01041666666666652 * sp[17];
    A[111] = -0.0944444444444448 * sp[19] + -0.03581349206349219 * sp[18] + -0.03978174603174627 * sp[18] + -0.02986111111111125 * sp[17];
    A[112] = 0.1630952380952393 * sp[19] + 0.08154761904761969 * sp[18] + 0.08154761904761969 * sp[18] + 0.06865079365079413 * sp[17];
    A[113] = -0.09444444444444491 * sp[19] + -0.05863095238095282 * sp[18] + -0.05466269841269859 * sp[18] + -0.04871031746031772 * sp[17];
    A[114] = 0.1346870059402921 * sp[19] + -0.07997040977705111 * sp[18] + 0.06594051332493436 * sp[18] + -0.07014948226057119 * sp[17];
    A[115] = 0.1030982623552916 * sp[19] + -0.1520699369740542 * sp[18] + 0.1022391101689944 * sp[18] + -0.1305911323167022 * sp[17];
    A[116] = -0.1071428571428562 * sp[19] + 0.0193452380952398 * sp[18] + -0.05605158730158685 * sp[18] + 0.02182539682539789 * sp[17];
    A[117] = 0.2946278254943947 * sp[18] + 0.002805979290422774 * sp[18] + 0.1487169023924084 * sp[17];
    A[118] = -0.2061965247105823 * sp[19] + -0.103098262355291 * sp[18] + -0.1030982623552911 * sp[18] + 0.1082531754730536 * sp[17];
    A[119] = -0.1458333333333376 * sp[18] + 0.004960317460317502 * sp[18] + -0.07043650793651018 * sp[17];
    A[120] = -0.02058531746031763 * sp[19] + 0.05820932539682568 * sp[18] + -0.007068452380952384 * sp[18] + 0.05114087301587336 * sp[17];
    A[121] = 0.02529761904761927 * sp[19] + -0.07524801587301647 * sp[18] + 0.01165674603174613 * sp[18] + -0.06111111111111164 * sp[17];
    A[122] = -0.0111607142857143 * sp[19] + 0.03266369047619069 * sp[18] + -0.006820436507936542 * sp[18] + 0.02385912698412714 * sp[17];
    A[123] = 0.01314484126984128 * sp[19] + 0.0438244047619049 * sp[18] + 0.004340277777777722 * sp[18] + 0.01116071428571435 * sp[17];
    A[124] = -0.01041666666666661 * sp[19] + -0.03358134920634904 * sp[18] + -0.00620039682539682 * sp[18] + -0.01190476190476189 * sp[17];
    A[125] = 0.01860119047619062 * sp[19] + 0.04308035714285731 * sp[18] + 0.009548611111111204 * sp[18] + 0.01860119047619051 * sp[17];
    A[126] = 0.0447420634920634 * sp[19] + 0.0223710317460317 * sp[18] + 0.02237103174603177 * sp[18] + 0.01765873015873014 * sp[17];
    A[127] = -0.09444444444444491 * sp[19] + -0.05466269841269859 * sp[18] + -0.05863095238095282 * sp[18] + -0.04871031746031772 * sp[17];
    A[128] = 0.1012896825396833 * sp[19] + 0.06850198412698466 * sp[18] + 0.06850198412698466 * sp[18] + 0.05734126984127033 * sp[17];
    A[129] = -0.1641497884897316 * sp[19] + -0.05822407027627437 * sp[18] + -0.09750778034219193 * sp[18] + -0.03507474113028572 * sp[17];
    A[130] = -0.2345485468582887 * sp[19] + -0.06142938132002955 * sp[18] + -0.1679642524204942 * sp[18] + -0.04209845712841184 * sp[17];
    A[131] = 0.2217261904761906 * sp[19] + 0.09945436507936598 * sp[18] + 0.1252480158730152 * sp[18] + 0.05109126984127009 * sp[17];
    A[132] = -0.04208968935634286 * sp[19] + -0.1950155606843832 * sp[18] + -0.01543288609732567 * sp[18] + -0.08979133729352931 * sp[17];
    A[133] = 0.1030982623552908 * sp[19] + 0.08763352300199834 * sp[18] + 0.02577456558882221 * sp[18] + -0.0463942180598793 * sp[17];
    A[134] = -0.07440476190476328 * sp[19] + -0.0590277777777796 * sp[18] + -0.02728174603174652 * sp[18] + -0.003968253968254601 * sp[17];
    A[135] = 0.04349267900155118 * sp[19] + -0.06243303921190634 * sp[18] + -0.02314932914598858 * sp[18] + 0.03507474113028572 * sp[17];
    A[136] = -0.07856742013183729 * sp[19] + 0.1360899955855054 * sp[18] + -0.009820927516479861 * sp[18] + 0.07014948226057126 * sp[17];
    A[137] = 0.1248660784238152 * sp[19] + -0.1283735525368425 * sp[18] + 0.01192541198429695 * sp[18] + -0.03507474113028571 * sp[17];
    A[138] = -0.0785674201318369 * sp[19] + -0.1529258713280409 * sp[18] + 0.02665680325901711 * sp[18] + 0.04208968935634283 * sp[17];
    A[139] = 0.1487169023924089 * sp[19] + 0.2946278254943949 * sp[18] + 0.002805979290422722 * sp[18];
    A[140] = -0.08979133729352939 * sp[19] + -0.1950155606843832 * sp[18] + -0.01543288609732559 * sp[18] + -0.04208968935634264 * sp[17];
    A[141] = -0.2062394778460752 * sp[19] + -0.09329881140655683 * sp[18] + 0.04700015311458275 * sp[18] + 0.03507474113028559 * sp[17];
    A[142] = 0.1346870059402921 * sp[19] + 0.06594051332493436 * sp[18] + -0.07997040977705111 * sp[18] + -0.07014948226057119 * sp[17];
    A[143] = -0.1641497884897316 * sp[19] + -0.09750778034219193 * sp[18] + -0.05822407027627437 * sp[18] + -0.03507474113028572 * sp[17];
    A[144] = 4.920634920634905 * sp[19] + 0.1984126984127013 * sp[18] + 0.1984126984127013 * sp[18] + 0.3968253968254029 * sp[17];
    A[145] = 0.02430049347996821 * sp[19] + -0.06075123369997182 * sp[18] + 0.23085468805993 * sp[18] + 0.607512336999806 * sp[17];
    A[146] = -0.5191061687282019 * sp[19] + -0.8067190459965525 * sp[18] + -0.3016427737204524 * sp[18] + -0.350747411302857 * sp[17];
    A[147] = -0.1984126984127014 * sp[19] + 4.305555555555532 * sp[18] + 0.01984126984127027 * sp[18] + -0.198412698412701 * sp[17];
    A[148] = -0.2187044413199088 * sp[19] + -0.03645074021998918 * sp[18] + 0.2551551815399185 * sp[18] + -0.2187044413199269 * sp[17];
    A[149] = -0.3507474113028557 * sp[19] + 0.5401510134063863 * sp[18] + 0.03507474113028582 * sp[18] + 0.3226876183986331 * sp[17];
    A[150] = 0.06529556615835226 * sp[19] + -0.1271545235715238 * sp[18] + -0.05154913117764575 * sp[18] + 0.06529556615835093 * sp[17];
    A[151] = -0.05326743555023482 * sp[19] + 0.1838585678669349 * sp[18] + -0.008591521862941593 * sp[18] + 0.08419691425682259 * sp[17];
    A[152] = -0.003436608745177813 * sp[19] + -0.05154913117764449 * sp[18] + -0.01718304372588163 * sp[18] + -0.003436608745176723 * sp[17];
    A[153] = -0.03522523963805743 * sp[19] + 0.02104922856420364 * sp[18] + 0.07947157723220399 * sp[18] + 0.1159855451497028 * sp[17];
    A[154] = -0.006873217490354661 * sp[19] + -0.1778445025628794 * sp[18] + -0.04725337024617508 * sp[18] + -0.1030982623552913 * sp[17];
    A[155] = -0.02663371777511721 * sp[19] + -0.007302793583500541 * sp[18] + -0.01073940232867682 * sp[18] + -0.0128872827944123 * sp[17];
    A[156] = 0.1314502845029981 * sp[19] + -0.0107394023286741 * sp[18] + 0.1576544261849666 * sp[18] + 0.1039574145415858 * sp[17];
    A[157] = 0.1030982623552916 * sp[19] + 0.1022391101689944 * sp[18] + -0.1520699369740542 * sp[18] + -0.1305911323167022 * sp[17];
    A[158] = -0.2345485468582887 * sp[19] + -0.1679642524204942 * sp[18] + -0.06142938132002955 * sp[18] + -0.04209845712841184 * sp[17];
    A[159] = 0.02430049347996821 * sp[19] + 0.23085468805993 * sp[18] + -0.06075123369997182 * sp[18] + 0.607512336999806 * sp[17];
    A[160] = 5.41666666666671 * sp[19] + 0.4315476190476358 * sp[18] + 0.4315476190476358 * sp[18] + 1.1309523809524 * sp[17];
    A[161] = -0.1890134809847103 * sp[19] + -0.0687321749035236 * sp[18] + -0.274928699614106 * sp[18] + -0.1890134809847029 * sp[17];
    A[162] = 0.170103454359953 * sp[19] + 0.449559129379842 * sp[18] + 0.1579532076199501 * sp[18] + -0.4131083891598575 * sp[17];
    A[163] = -0.4017857142857227 * sp[19] + 3.593749999999995 * sp[18] + 0.5580357142857226 * sp[18] + -0.4017857142857143 * sp[17];
    A[164] = 0.3007032652029477 * sp[19] + 0.1761261981902896 * sp[18] + 0.2792244605455833 * sp[18] + 0.3007032652029436 * sp[17];
    A[165] = -0.01686507936508155 * sp[19] + 0.07192460317460256 * sp[18] + -0.007440476190475894 * sp[18] + -0.01091269841269933 * sp[17];
    A[166] = -0.004960317460314449 * sp[19] + -0.162698412698412 * sp[18] + 0.01984126984126932 * sp[18] + -0.1021825396825407 * sp[17];
    A[167] = 0.1001984126984121 * sp[19] + 0.1026785714285714 * sp[18] + -0.07192460317460356 * sp[18] + 0.1180555555555573 * sp[17];
    A[168] = -0.04513888888888819 * sp[19] + 0.005704365079364414 * sp[18] + 0.04340277777777804 * sp[18] + 0.05208333333333301 * sp[17];
    A[169] = 0.1289682539682536 * sp[19] + -0.01636904761904652 * sp[18] + -0.09176587301587369 * sp[18] + -0.1785714285714299 * sp[17];
    A[170] = -0.03819444444444239 * sp[19] + 0.1054067460317488 * sp[18] + 0.0359623015873014 * sp[18] + 0.1264880952380962 * sp[17];
    A[171] = 0.1473214285714274 * sp[19] + 0.04935515873015868 * sp[18] + 0.1068948412698421 * sp[18] + 0.05605158730158797 * sp[17];
    A[172] = -0.1071428571428562 * sp[19] + -0.05605158730158685 * sp[18] + 0.0193452380952398 * sp[18] + 0.02182539682539789 * sp[17];
    A[173] = 0.2217261904761906 * sp[19] + 0.1252480158730152 * sp[18] + 0.09945436507936598 * sp[18] + 0.05109126984127009 * sp[17];
    A[174] = -0.5191061687282019 * sp[19] + -0.3016427737204524 * sp[18] + -0.8067190459965525 * sp[18] + -0.350747411302857 * sp[17];
    A[175] = -0.1890134809847103 * sp[19] + -0.274928699614106 * sp[18] + -0.0687321749035236 * sp[18] + -0.1890134809847029 * sp[17];
    A[176] = 5.555555555555569 * sp[19] + 0.5902777777777787 * sp[18] + 0.5902777777777787 * sp[18] + 0.9126984126984279 * sp[17];
    A[177] = -0.3507474113028581 * sp[19] + -0.3016427737204438 * sp[18] + 0.2034334985556566 * sp[18] + -0.01402989645209667 * sp[17];
    A[178] = 0.07732369676647521 * sp[19] + 0.1675346763273475 * sp[18] + 0.06443641397205577 * sp[18] + 0.07732369676647219 * sp[17];
    A[179] = -0.6200396825396941 * sp[19] + 3.395337301587293 * sp[18] + 0.3596230158730212 * sp[18] + -0.6200396825397022 * sp[17];
    A[180] = 0.0350747411302857 * sp[19] + -0.01192541198429703 * sp[18] + 0.1283735525368425 * sp[18] + -0.1248660784238149 * sp[17];
    A[181] = -0.07014948226057131 * sp[19] + 0.009820927516479946 * sp[18] + -0.1360899955855055 * sp[18] + 0.07856742013183721 * sp[17];
    A[182] = -0.03507474113028577 * sp[19] + 0.02314932914598859 * sp[18] + 0.06243303921190652 * sp[18] + -0.04349267900155117 * sp[17];
    A[183] = 0.03507474113028566 * sp[19] + 0.04700015311458292 * sp[18] + -0.09329881140655678 * sp[18] + -0.206239477846075 * sp[17];
    A[184] = -0.07014948226057144 * sp[19] + -0.07997040977705143 * sp[18] + 0.06594051332493446 * sp[18] + 0.134687005940292 * sp[17];
    A[185] = -0.03507474113028559 * sp[19] + -0.05822407027627423 * sp[18] + -0.09750778034219186 * sp[18] + -0.1641497884897315 * sp[17];
    A[186] = 0.04208968935634284 * sp[19] + 0.02665680325901718 * sp[18] + -0.1529258713280408 * sp[18] + -0.07856742013183672 * sp[17];
    A[187] = 0.002805979290422774 * sp[18] + 0.2946278254943947 * sp[18] + 0.1487169023924084 * sp[17];
    A[188] = -0.04208968935634286 * sp[19] + -0.01543288609732567 * sp[18] + -0.1950155606843832 * sp[18] + -0.08979133729352931 * sp[17];
    A[189] = -0.1984126984127014 * sp[19] + 0.01984126984127027 * sp[18] + 4.305555555555532 * sp[18] + -0.198412698412701 * sp[17];
    A[190] = 0.170103454359953 * sp[19] + 0.1579532076199501 * sp[18] + 0.449559129379842 * sp[18] + -0.4131083891598575 * sp[17];
    A[191] = -0.3507474113028581 * sp[19] + 0.2034334985556566 * sp[18] + -0.3016427737204438 * sp[18] + -0.01402989645209667 * sp[17];
    A[192] = 0.3968253968254036 * sp[19] + 0.1984126984127017 * sp[18] + 0.1984126984127017 * sp[18] + 4.920634920634906 * sp[17];
    A[193] = -0.1458029608799466 * sp[18] + -0.7290148043997466 * sp[18] + -0.4374088826398536 * sp[17];
    A[194] = 0.7014948226057137 * sp[19] + 0.3507474113028564 * sp[18] + 0.3507474113028569 * sp[18] + 0.2805979290422581 * sp[17];
    A[195] = -0.1005208057964094 * sp[19] + 0.07088005536926253 * sp[18] + -0.06314768569261546 * sp[18] + -0.08505606644311359 * sp[17];
    A[196] = 0.04639421805988039 * sp[19] + -0.0128872827944107 * sp[18] + 0.04897167461876194 * sp[18] + 0.03092947870658564 * sp[17];
    A[197] = -0.02319710902993973 * sp[19] + 0.03221820698602828 * sp[18] + 0.001288728279440923 * sp[18] + -0.01804219591217504 * sp[17];
    A[198] = 0.1005208057964093 * sp[19] + 0.1714008611656716 * sp[18] + 0.03737312010379358 * sp[18] + 0.193309241916169 * sp[17];
    A[199] = -0.04639421805988034 * sp[19] + -0.0592815008542907 * sp[18] + 0.002577456558881674 * sp[18] + -0.04123930494211438 * sp[17];
    A[200] = 0.02319710902993964 * sp[19] + 0.05541531601596784 * sp[18] + 0.02448583730938055 * sp[18] + 0.07474624020758397 * sp[17];
    A[201] = 0.1030982623552904 * sp[19] + 0.0773236967664685 * sp[18] + 0.01546473935329245 * sp[18] + -0.05670404429540906 * sp[17];
    A[202] = -0.2061965247105823 * sp[19] + -0.1030982623552911 * sp[18] + -0.103098262355291 * sp[18] + 0.1082531754730536 * sp[17];
    A[203] = 0.1030982623552908 * sp[19] + 0.02577456558882221 * sp[18] + 0.08763352300199834 * sp[18] + -0.0463942180598793 * sp[17];
    A[204] = -0.2187044413199088 * sp[19] + 0.2551551815399185 * sp[18] + -0.03645074021998918 * sp[18] + -0.2187044413199269 * sp[17];
    A[205] = -0.4017857142857227 * sp[19] + 0.5580357142857226 * sp[18] + 3.593749999999995 * sp[18] + -0.4017857142857143 * sp[17];
    A[206] = 0.07732369676647521 * sp[19] + 0.06443641397205577 * sp[18] + 0.1675346763273475 * sp[18] + 0.07732369676647219 * sp[17];
    A[207] = -0.7290148043997466 * sp[18] + -0.1458029608799466 * sp[18] + -0.4374088826398536 * sp[17];
    A[208] = 0.8035714285714417 * sp[19] + 0.4017857142857193 * sp[18] + 0.4017857142857193 * sp[18] + 5.357142857142864 * sp[17];
    A[209] = -0.05154913117763561 * sp[18] + -0.2577456558882177 * sp[18] + -0.1546473935329273 * sp[17];
    A[210] = 0.06200396825396932 * sp[19] + -0.02108134920634947 * sp[18] + 0.09598214285714173 * sp[18] + 0.05307539682539843 * sp[17];
    A[211] = -0.1240079365079386 * sp[19] + 0.01736111111111141 * sp[18] + -0.2405753968253962 * sp[18] + 0.04365079365079547 * sp[17];
    A[212] = -0.06200396825396937 * sp[19] + 0.04092261904761976 * sp[18] + 0.1460813492063478 * sp[18] + -0.06498015873016073 * sp[17];
    A[213] = 0.06200396825396924 * sp[19] + 0.08308531746031904 * sp[18] + -0.03397817460317279 * sp[18] + 0.04017857142857455 * sp[17];
    A[214] = -0.1240079365079386 * sp[19] + -0.14136904761905 * sp[18] + 0.1165674603174581 * sp[18] + 0.1428571428571432 * sp[17];
    A[215] = -0.06200396825396918 * sp[19] + -0.102926587301589 * sp[18] + -0.2080853174603167 * sp[18] + -0.3139880952380974 * sp[17];
    A[216] = 0.07440476190476315 * sp[19] + 0.04712301587301671 * sp[18] + 0.01537698412698339 * sp[18] + -0.007936507936507952 * sp[17];
    A[217] = 0.004960317460317502 * sp[18] + -0.1458333333333376 * sp[18] + -0.07043650793651018 * sp[17];
    A[218] = -0.07440476190476328 * sp[19] + -0.02728174603174652 * sp[18] + -0.0590277777777796 * sp[18] + -0.003968253968254601 * sp[17];
    A[219] = -0.3507474113028557 * sp[19] + 0.03507474113028582 * sp[18] + 0.5401510134063863 * sp[18] + 0.3226876183986331 * sp[17];
    A[220] = 0.3007032652029477 * sp[19] + 0.2792244605455833 * sp[18] + 0.1761261981902896 * sp[18] + 0.3007032652029436 * sp[17];
    A[221] = -0.6200396825396941 * sp[19] + 0.3596230158730212 * sp[18] + 3.395337301587293 * sp[18] + -0.6200396825397022 * sp[17];
    A[222] = 0.7014948226057137 * sp[19] + 0.3507474113028569 * sp[18] + 0.3507474113028564 * sp[18] + 0.2805979290422581 * sp[17];
    A[223] = -0.2577456558882177 * sp[18] + -0.05154913117763561 * sp[18] + -0.1546473935329273 * sp[17];
    A[224] = 1.240079365079386 * sp[19] + 0.6200396825396933 * sp[18] + 0.6200396825396933 * sp[18] + 5.61507936507941 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f7ade342237e5af4964c4356cf0b121fecb7c546c2c72d54a3d7f9c3718a8755a939353c4e59adb32539a005c2463fb5e8af82bc1aadd81f9dfdc51a48bee4cd";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "a3226853386d2b74b50fbefb85d9e0f4f839379042f756b24439e8ccc90d14f112726c9f00229d697576706f783f14fe1fb718aff5c3d4d48b40494a4aef7b2b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
